﻿let FWEditor = (function() {
	let version = "0.33";
	let lastupdate = "2017/10/22";
	let idcount = 0;
	let Sqsize = 16;
	let Maxwidth = 100;
	let Maxheight = 100;
	let Defaultwidth = 20;
	let Defaultheight = 20;
	let Terrain_UI_width = 30;

	let Toolwidth = 260;
	let Toolheight = 350;

	let Country = [ 
		{ fname: "no", npc: true },
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
	];
	let Countrynamenum = {
		"rs": 0,
		"bm": 1,
		"ge": 2,
		"yc": 3,
		"bh": 4,
	};

	let Terrain = {
		plain:					{ defence: 1, name:	"平地",				imgdata: { num: 0, ix: 1, iy :0, height: 16 } },
		wood:						{ defence: 2, name:	"森",					imgdata: { num: 1, ix: 1, iy :0, height: 32 } },
		mountain:				{ defence: 4, name:	"山",					imgdata: { num: 1, ix: 3, iy :0, height: 32 } },
		road:						{ defence: 0, name: "道路",				imgdata: { num: 0, ix: 7, iy :3, height: 16 } },
		bridge:					{ defence: 0, name: "橋",					imgdata: { num: 0, ix: 21, iy: 0, height: 16 } },
		pipe:						{ defence: 0, name: "パイプ",			imgdata: { num: 0, ix: 3, iy: 11, height: 16 } },
		pipe_c:					{ defence: 0, name: "パイプ",			imgdata: { num: 0, ix: 5, iy : 12, height: 16 }, candestroy: true },
		river:					{ defence: 0, name: "川",					imgdata: { num: 0, ix: 25, iy: 0, height: 16 } },
		sea:						{ defence: 0, name: "海",					imgdata: { num: 0, ix: 12, iy: 1, height: 16 } },
		reef:						{ defence: 1, name: "岩礁",				imgdata: { num: 0, ix: 11, iy: 12, height: 16 } },
		shoal:					{ defence: 0, name: "浅瀬",				imgdata: { num: 0, ix: 10, iy: 8, height: 16 } },
		missle:					{ defence: 3, name: "Ｍ基地",			imgdata: { num: 3, ix: 0, iy: 0, height: 32 } },
		misslenone:			{ defence: 3, name: "Ｍ基地",			imgdata: { num: 3, ix: 6, iy: 1, height: 16 } },
		mcannon:				{ defence: 0, name: "Ｍキャノン",	imgdata: { num: 3, ix: 2, iy :  0, height: 32 }, candestroy: true },
		bstone:					{ defence: 0, name: "Ｂストーン",	imgdata: { num: 3, ix: 7, iy :  0, height: 32 }, candestroy: true },
		hq:							{	defence: 4, name: "本部",				building: true,	imgdata: { num: 2, ix: 0, iy : 0, height: 32 } },
		city:						{	defence: 3, name: "都市",				building: true,	imgdata: { num: 2, ix: 6, iy : 0, height: 32 } },
		base:						{	defence: 3, name: "工場",				building: true,	imgdata: { num: 2, ix: 6, iy : 2, height: 32 }},
		airport:				{	defence: 3, name: "空港",				building: true,	imgdata: { num: 2, ix: 6, iy : 4, height: 32 } },
		seaport:				{	defence: 3, name: "港",					building: true,	imgdata: { num: 2, ix: 6, iy : 6, height: 32 } },
		comtower: 			{	defence: 3, name: "司令塔",			building: true,	imgdata: { num: 2, ix: 6, iy : 8, height: 32 } },
		rlab:						{	defence: 4, name: "研究所",			building: true,	imgdata: { num: 2, ix: 0, iy : 10, height: 32 } },
		bcannon:				{ defence: 0, name: "Ｂキャノン",	imgdata: { num: 4, ix: 3, iy : 0, height: 48, large: true } },
		bcannond:				{ defence: 0, name: "Ｂキャノン",	imgdata: { num: 4, ix: 3, iy : 0, height: 48, large: true }, candestroy: true },
		bcrystal:				{ defence: 0, name: "Ｂクリスタル",imgdata: { num: 4, ix: 6, iy : 0, height: 48, large: true } },
		bcrystald:			{ defence: 0, name: "Ｂクリスタル",imgdata: { num: 4, ix: 6, iy : 0, height: 48, large: true }, candestroy: true },
		cannotenter:		{ defence: 0, name: "侵入不可",		imgdata: { num: 0, ix: 0, iy : 0, height: 16 }, cannotenter: true },
	};

	let Terrain_imglist = {
		plain:			{ name: "plain", land: true, receiveshadow: true, imgdata: { num: 0, ix: 1, iy :0, sx: 3, sy: 1, height: 16 } },
		plains:			{ name: "plain", land: true, imgdata: { num: 0, ix: 3, iy: 1, height: 16 } },
		plainns:		{ name: "plain", land: true, imgdata: { num: 0, ix: 1, iy :0, sx: 3, sy: 1, height: 16 } },
		plain_pd:		{ name: "plain", land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 4, iy :0, height: 16 } },
		wood:				{ name: "wood", land: true, receiveshadow: true, shadow: true, imgdata: { num: 1, ix: 1, iy: 0, sx: 2, sy: 0, height: 32 } },
		woods:			{ name: "wood", land: true, shadow: true, imgdata: { num: 1, ix: 2, iy: 0, height: 32 } },
		woodns:			{ name: "wood", land: true, shadow: true, imgdata: { num: 1, ix: 1, iy: 0, sx: 2, sy: 0, height: 32 } },
		mountain:		{ name: "mountain", land: true, shadow: true, imgdata: { num: 1, ix: 3, iy:0, height: 32 } },
		mountain2:	{ name: "mountain", land: true, shadow: true, imgdata: { num: 1, ix: 0, iy:0, height: 32 } },
		mountain3:	{ name: "mountain", land: true, shadow: true, imgdata: { num: 1, ix: 4, iy:0, height: 32 } },
		road:				{ name: "road", land: true, connect: true, receiveshadow: true, imgdata: { num: 0, ix: 7, iy :3, height: 16 } },
		bridge:			{ name: "bridge", connect: true, imgdata: { num: 0, ix: 21, iy: 0, height: 16 } },
		pipe:				{ name: "pipe", land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 3, iy: 11, height: 16 } },
		pipe_c:			{ name: "pipe_c", land: true, pipe: true, connect: true, candestroy: true, hp: 99, imgdata: { num: 0, ix: 5, iy: 12, height: 16 } },
		river:			{ name: "river", land: true, connect: true, imgdata: { num: 0, ix: 25, iy: 0, height: 16 } },
		sea:				{ name: "sea", sea: true, connect: true, imgdata: { num: 0, ix: 12, iy: 1, height: 16 } },
		reef:				{ name: "reef", sea: true, imgdata: { num: 0, ix: 11, iy: 12, height: 16 } },
		shoal:			{ name: "shoal", sea: true, connect: true, imgdata: { num: 0, ix: 10, iy: 8, height: 16 } },
		missle:			{ name: "missle", land: true, shadow: true, imgdata: { num: 3, ix: 0, iy: 0, height: 32 } },
		misslenone:	{ name: "misslenone", land: true, shadow: true, imgdata: { num: 3, ix: 6, iy: 1, height: 16 } },
		wideriver:	{ name: "river", land: true, connect: true, imgdata: { num: 0, ix: 1, iy :1, height: 16 } },
		road10:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  7, iy : 3, sx: 11, sy: 5, height: 16 } },
		road5:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		road3:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		road6:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		road12:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		road9:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		road7:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		road14:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 } },
		road13:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		road11:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		road15:			{ name: "road", land: true, receiveshadow: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 } },
		road10s:		{ name: "road", land: true, imgdata: { num: 0, ix: 11, iy: 5, height: 16 } },
		road5s:			{ name: "road", land: true, imgdata: { num: 0, ix:  8, iy: 4, height: 16 } },
		road3s:			{ name: "road", land: true, imgdata: { num: 0, ix: 10, iy: 5, height: 16 } },
		road6s:			{ name: "road", land: true, imgdata: { num: 0, ix:  9, iy: 4, height: 16 } },
		road12s:		{ name: "road", land: true, imgdata: { num: 0, ix: 10, iy: 4, height: 16 } },
		road9s:			{ name: "road", land: true, imgdata: { num: 0, ix: 12, iy: 5, height: 16 } },
		road7s:			{ name: "road", land: true, imgdata: { num: 0, ix: 28, iy: 7, height: 16 } },
		road14s:		{ name: "road", land: true, imgdata: { num: 0, ix: 27, iy: 7, height: 16 } },
		road13s:		{ name: "road", land: true, imgdata: { num: 0, ix: 25, iy: 6, height: 16 } },
		road11s:		{ name: "road", land: true, imgdata: { num: 0, ix: 24, iy: 6, height: 16 } },
		road15s:		{ name: "road", land: true, imgdata: { num: 0, ix: 28, iy: 8, height: 16 } },
		road10s:		{ name: "road", land: true, imgdata: { num: 0, ix: 11, iy: 5, height: 16 } },
		road5ns:		{ name: "road", land: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		road3ns:		{ name: "road", land: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		road6ns:		{ name: "road", land: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		road12ns:		{ name: "road", land: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		road9ns:		{ name: "road", land: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		road7ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		road14ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 } },
		road13ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		road11ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		road15ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 } },
		road10ns:		{ name: "road", land: true, imgdata: { num: 0, ix: 11, iy: 5, height: 16 } },
		bridgeh:		{ name: "bridge", imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		bridgev:		{ name: "bridge", imgdata: { num: 0, ix: 22, iy : 0, height: 16 } },
		pipe10:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 11, height: 16 } },
		pipe5:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 11, height: 16 } },
		pipe3:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 12, height: 16 } },
		pipe6:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 11, height: 16 } },
		pipe12:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 11, height: 16 } },
		pipe9:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 12, height: 16 } },
		pipe4:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  8, height: 16 } },
		pipe8:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  0, iy : 10, height: 16 } },
		pipe1:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix:  0, iy :  9, height: 16 } },
		pipe2:			{ name: "pipe", land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  9, height: 16 } },
		pipe_cv:		{ name: "pipe_c", land: true, pipe: true, imgdata: { num: 0, ix:  6, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		pipe_ch:		{ name: "pipe_c", land: true, pipe: true, imgdata: { num: 0, ix:  5, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		plain_pdh:	{ name: "plain", land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 10, height: 16 } },
		plain_pdv:	{ name: "plain", land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 10, height: 16 } },
		river10:		{ name: "river", land: true, imgdata: { num: 0, ix: 25, iy :  0, height: 16 } },
		river5:			{ name: "river", land: true, imgdata: { num: 0, ix: 24, iy :  0, height: 16 } },
		river19:		{ name: "river", land: true, imgdata: { num: 0, ix:  2, iy :  4, height: 16 } },
		river38:		{ name: "river", land: true, imgdata: { num: 0, ix:  0, iy :  3, height: 16 } },
		river76:		{ name: "river", land: true, imgdata: { num: 0, ix:  1, iy :  3, height: 16 } },
		river137:		{ name: "river", land: true, imgdata: { num: 0, ix:  3, iy :  4, height: 16 } },
		river55:		{ name: "river", land: true, imgdata: { num: 0, ix: 19, iy :  7, height: 16 } },
		river110:		{ name: "river", land: true, imgdata: { num: 0, ix: 22, iy :  9, height: 16 } },
		river205:		{ name: "river", land: true, imgdata: { num: 0, ix: 20, iy :  7, height: 16 } },
		river155:		{ name: "river", land: true, imgdata: { num: 0, ix: 24, iy : 10, height: 16 } },
		river255:		{ name: "river", land: true, imgdata: { num: 0, ix: 27, iy :  0, height: 16 } },
		river3:			{ name: "river", land: true, imgdata: { num: 0, ix:  6, iy :  6, height: 16 } },
		river6:			{ name: "river", land: true, imgdata: { num: 0, ix:  4, iy :  5, height: 16 } },
		river12:		{ name: "river", land: true, imgdata: { num: 0, ix:  5, iy :  5, height: 16 } },
		river9:			{ name: "river", land: true, imgdata: { num: 0, ix:  7, iy :  6, height: 16 } },
		river7:			{ name: "river", land: true, imgdata: { num: 0, ix:  4, iy :  3, height: 16 } },
		river23:		{ name: "river", land: true, imgdata: { num: 0, ix:  8, iy :  5, height: 16 } },
		river39:		{ name: "river", land: true, imgdata: { num: 0, ix:  6, iy :  4, height: 16 } },
		river14:		{ name: "river", land: true, imgdata: { num: 0, ix:  0, iy :  2, height: 16 } },
		river46:		{ name: "river", land: true, imgdata: { num: 0, ix: 20, iy :  6, height: 16 } },
		river78:		{ name: "river", land: true, imgdata: { num: 0, ix: 21, iy :  6, height: 16 } },
		river13:		{ name: "river", land: true, imgdata: { num: 0, ix:  5, iy :  3, height: 16 } },
		river77:		{ name: "river", land: true, imgdata: { num: 0, ix:  7, iy :  4, height: 16 } },
		river141:		{ name: "river", land: true, imgdata: { num: 0, ix:  9, iy :  5, height: 16 } },
		river11:		{ name: "river", land: true, imgdata: { num: 0, ix:  1, iy :  2, height: 16 } },
		river139:		{ name: "river", land: true, imgdata: { num: 0, ix: 24, iy :  7, height: 16 } },
		river27:		{ name: "river", land: true, imgdata: { num: 0, ix: 23, iy :  7, height: 16 } },
		river15:		{ name: "river", land: true, imgdata: { num: 0, ix:  1, iy :  1, height: 16 } },
		sea_r1:			{ name: "sea", imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ name: "sea", imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ name: "sea", imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ name: "sea", imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		sea0:				{ name: "sea", imgdata: { num: 0, ix: 12, iy :  1, height: 16 } },
		sea1:				{ name: "sea", imgdata: { num: 0, ix: 14, iy :  2, height: 16 } },
		sea2:				{ name: "sea", imgdata: { num: 0, ix: 10, iy :  1, height: 16 } },
		sea4:				{ name: "sea", imgdata: { num: 0, ix: 10, iy :  0, height: 16 } },
		sea8:				{ name: "sea", imgdata: { num: 0, ix: 14, iy :  1, height: 16 } },
		sea5:				{ name: "sea", imgdata: { num: 0, ix: 18, iy :  3, height: 16 } },
		sea10:			{ name: "sea", imgdata: { num: 0, ix: 12, iy :  0, height: 16 } },
		sea3:				{ name: "sea", imgdata: { num: 0, ix: 13, iy :  2, height: 16 } },
		sea6:				{ name: "sea", imgdata: { num: 0, ix: 11, iy :  1, height: 16 } },
		sea12:			{ name: "sea", imgdata: { num: 0, ix: 13, iy :  1, height: 16 } },
		sea9:				{ name: "sea", imgdata: { num: 0, ix: 15, iy :  2, height: 16 } },
		sea7:				{ name: "sea", imgdata: { num: 0, ix: 19, iy :  4, height: 16 } },
		sea14:			{ name: "sea", imgdata: { num: 0, ix: 17, iy :  4, height: 16 } },
		sea13:			{ name: "sea", imgdata: { num: 0, ix: 16, iy :  3, height: 16 } },
		sea11:			{ name: "sea", imgdata: { num: 0, ix: 14, iy :  3, height: 16 } },
		sea15:			{ name: "sea", imgdata: { num: 0, ix:  8, iy :  0, height: 16 } },
		sea16:			{ name: "sea", imgdata: { num: 0, ix: 12, iy :  2, height: 16 } },
		sea32:			{ name: "sea", imgdata: { num: 0, ix:  9, iy :  0, height: 16 } },
		sea64:			{ name: "sea", imgdata: { num: 0, ix: 11, iy :  0, height: 16 } },
		sea128:			{ name: "sea", imgdata: { num: 0, ix: 16, iy :  2, height: 16 } },
		sea48:			{ name: "sea", imgdata: { num: 0, ix: 18, iy :  4, height: 16 } },
		sea80:			{ name: "sea", imgdata: { num: 0, ix: 13, iy :  0, height: 16 } },
		sea144:			{ name: "sea", imgdata: { num: 0, ix: 16, iy :  4, height: 16 } },
		sea96:			{ name: "sea", imgdata: { num: 0, ix: 15, iy :  3, height: 16 } },
		sea160:			{ name: "sea", imgdata: { num: 0, ix: 15, iy :  1, height: 16 } },
		sea192:			{ name: "sea", imgdata: { num: 0, ix: 17, iy :  3, height: 16 } },
		sea112:			{ name: "sea", imgdata: { num: 0, ix:  7, iy : 10, height: 16 } },
		sea176:			{ name: "sea", imgdata: { num: 0, ix:  9, iy : 10, height: 16 } },
		sea208:			{ name: "sea", imgdata: { num: 0, ix: 10, iy : 10, height: 16 } },
		sea224:			{ name: "sea", imgdata: { num: 0, ix:  8, iy : 10, height: 16 } },
		sea240:			{ name: "sea", imgdata: { num: 0, ix: 11, iy : 10, height: 16 } },
		sea33:			{ name: "sea", imgdata: { num: 0, ix:  3, iy :  8, height: 16 } },
		sea65:			{ name: "sea", imgdata: { num: 0, ix:  4, iy :  8, height: 16 } },
		sea97:			{ name: "sea", imgdata: { num: 0, ix:  5, iy :  8, height: 16 } },
		sea66:			{ name: "sea", imgdata: { num: 0, ix: 19, iy :  5, height: 16 } },
		sea130:			{ name: "sea", imgdata: { num: 0, ix:  1, iy :  7, height: 16 } },
		sea194:			{ name: "sea", imgdata: { num: 0, ix: 21, iy :  5, height: 16 } },
		sea132:			{ name: "sea", imgdata: { num: 0, ix:  6, iy :  9, height: 16 } },
		sea20:			{ name: "sea", imgdata: { num: 0, ix:  5, iy :  9, height: 16 } },
		sea148:			{ name: "sea", imgdata: { num: 0, ix:  7, iy :  9, height: 16 } },
		sea24:			{ name: "sea", imgdata: { num: 0, ix:  0, iy :  7, height: 16 } },
		sea40:			{ name: "sea", imgdata: { num: 0, ix: 18, iy :  5, height: 16 } },
		sea56:			{ name: "sea", imgdata: { num: 0, ix: 20, iy :  5, height: 16 } },
		sea67:			{ name: "sea", imgdata: { num: 0, ix:  7, iy :  8, height: 16 } },
		sea134:			{ name: "sea", imgdata: { num: 0, ix:  9, iy :  9, height: 16 } },
		sea28:			{ name: "sea", imgdata: { num: 0, ix:  8, iy :  9, height: 16 } },
		sea41:			{ name: "sea", imgdata: { num: 0, ix:  6, iy :  8, height: 16 } },
		sea_r1:			{ name: "sea", imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ name: "sea", imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ name: "sea", imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ name: "sea", imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		shoal1:			{ name: "shoal", imgdata: { num: 0, ix: 10, iy :  8, height: 16 } },
		shoal17:		{ name: "shoal", imgdata: { num: 0, ix:  5, iy :  7, height: 16 } },
		shoal129:		{ name: "shoal", imgdata: { num: 0, ix:  6, iy :  7, height: 16 } },
		shoal145:		{ name: "shoal", imgdata: { num: 0, ix: 20, iy :  2, height: 16 } },
		shoal2:			{ name: "shoal", imgdata: { num: 0, ix: 26, iy :  4, height: 16 } },
		shoal34:		{ name: "shoal", imgdata: { num: 0, ix: 25, iy :  5, height: 16 } },
		shoal18:		{ name: "shoal", imgdata: { num: 0, ix:  7, iy :  7, height: 16 } },
		shoal50:		{ name: "shoal", imgdata: { num: 0, ix: 16, iy :  1, height: 16 } },
		shoal4:			{ name: "shoal", imgdata: { num: 0, ix: 23, iy :  4, height: 16 } },
		shoal68:		{ name: "shoal", imgdata: { num: 0, ix: 20, iy :  3, height: 16 } },
		shoal36:		{ name: "shoal", imgdata: { num: 0, ix: 19, iy :  3, height: 16 } },
		shoal100:		{ name: "shoal", imgdata: { num: 0, ix: 16, iy :  0, height: 16 } },
		shoal8:			{ name: "shoal", imgdata: { num: 0, ix: 27, iy :  4, height: 16 } },
		shoal136:		{ name: "shoal", imgdata: { num: 0, ix:  8, iy :  7, height: 16 } },
		shoal72:		{ name: "shoal", imgdata: { num: 0, ix: 26, iy :  5, height: 16 } },
		shoal200:		{ name: "shoal", imgdata: { num: 0, ix: 20, iy :  1, height: 16 } },
		shoal3:			{ name: "shoal", imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal35:		{ name: "shoal", imgdata: { num: 0, ix: 28, iy :  5, height: 16 } },
		shoal131:		{ name: "shoal", imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal163:		{ name: "shoal", imgdata: { num: 0, ix: 18, iy :  2, height: 16 } },
		shoal6:			{ name: "shoal", imgdata: { num: 0, ix: 12, iy :  6, height: 16 } },
		shoal70:		{ name: "shoal", imgdata: { num: 0, ix: 14, iy :  8, height: 16 } },
		shoal22:		{ name: "shoal", imgdata: { num: 0, ix: 10, iy :  7, height: 16 } },
		shoal86:		{ name: "shoal", imgdata: { num: 0, ix: 17, iy :  1, height: 16 } },
		shoal12:		{ name: "shoal", imgdata: { num: 0, ix: 13, iy :  6, height: 16 } },
		shoal140:		{ name: "shoal", imgdata: { num: 0, ix: 11, iy :  7, height: 16 } },
		shoal44:		{ name: "shoal", imgdata: { num: 0, ix: 13, iy :  8, height: 16 } },
		shoal172:		{ name: "shoal", imgdata: { num: 0, ix: 19, iy :  1, height: 16 } },
		shoal9:			{ name: "shoal", imgdata: { num: 0, ix: 16, iy :  7, height: 16 } },
		shoal25:		{ name: "shoal", imgdata: { num: 0, ix: 15, iy :  9, height: 16 } },
		shoal73:		{ name: "shoal", imgdata: { num: 0, ix: 29, iy :  5, height: 16 } },
		shoal89:		{ name: "shoal", imgdata: { num: 0, ix: 21, iy :  2, height: 16 } },
		shoal7:			{ name: "shoal", imgdata: { num: 0, ix: 24, iy :  2, height: 16 } },
		shoal14:		{ name: "shoal", imgdata: { num: 0, ix: 25, iy :  2, height: 16 } },
		shoal13:		{ name: "shoal", imgdata: { num: 0, ix: 23, iy :  2, height: 16 } },
		shoal11:		{ name: "shoal", imgdata: { num: 0, ix: 27, iy :  3, height: 16 } },
		mcannon_u:	{ name: "mcannon", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 3, iy :  0, height: 32 } },
		mcannon_r:	{ name: "mcannon", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 5, iy :  0, height: 32 } },
		mcannon_d:	{ name: "mcannon", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 2, iy :  0, height: 32 } },
		mcannon_l:	{ name: "mcannon", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 4, iy :  0, height: 32 } },
		mcannon_all:	{ name: "mcannon", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 1, iy :  0, height: 32 } },
		bstone:				{ name: "bstone", land: true, candestroy: true, hp: 99, shadow: true, newline: true, imgdata: { num: 3, ix: 7, iy :  0, height: 32 } },
		mcannon_airl:	{ name: "mcannon", candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 8, iy :  0, height: 32 } },
	};

	let Buildinglist = {
		hq:				{	name: "hq", land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 0, height: 32 } },
		city:			{	name: "city", land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 0, height: 32 } },
		base:			{	name: "base", land: true, shadow: true , imgdata: { num: 2, ix: 6, iy : 2, height: 32 }},
		airport:	{	name: "airport", land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 4, height: 32 } },
		seaport:	{	name: "seaport", land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 6, height: 32 } },
		comtower: {	name: "comtower", land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 8, height: 32 } },
		rlab:			{	name: "rlab", land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 10, height: 32 } },
	}

	let LargeBuildinglist = {
		bcannon_u:	{ name: "bcannon", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 3, iy : 0, height: 48 } },
		bcannon_d:	{ name: "bcannon", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 0, iy : 0, height: 48 } },
		bcrystal:		{ name: "bcrystal", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 6, iy : 0, height: 48 } },
		bruin:			{ name: "cannotenter", land: true, large: true, size: 3, imgdata: { num: 4, ix: 9, iy : 0, height: 48 } },
		misslelauncher:	{ name: "cannotenter", land: true, large: true, size: 4, imgdata: { num: 4, ix: 0, iy : 3, height: 64 } },
		largebuilding:	{ name: "cannotenter", land: true, large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 3, height: 64 } },
		volcano:		{ name: "cannotenter", land: true, large: true, size: 4, imgdata: { num: 4, ix: 8, iy : 3, height: 64 } },
		blackarc:		{ name: "cannotenter", large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 7, height: 64 } },
	};

	let Unit = {
		infantry:		{	name:	"歩兵",						movement: 3,	ammo: 0,	vision: 2,	range: 1,	fuel:	99,	cost: 1000,		mtype: "infantry",	cancapture: true },
		mech:				{	name:	"バズーカ兵",			movement: 2,	ammo: 3,	vision: 2,	range: 1,	fuel:	70,	cost: 3000,		mtype: "mech",			cancapture: true },
		apc:				{	name:	"輸送車",					movement: 6,	ammo: 0,	vision: 1,	range: 0,	fuel:	70,	cost: 5000,		mtype: "tank",			cansupply: true,	canload:	true },
		oozium: 		{	name:	"ヘルリウム",			movement: 1,	ammo: 0,	vision: 1,	range: 0,	fuel:	0,	cost: 0,			mtype: "oozium" },
		recon:			{	name:	"偵察車",					movement: 8,	ammo: 0,	vision: 5,	range: 1,	fuel:	80,	cost: 4000,		mtype: "wheel" },
		tank:				{	name:	"軽戦車",					movement: 6,	ammo: 9,	vision: 3,	range: 1,	fuel:	70,	cost: 7000,		mtype: "tank" },
		mdtank:			{	name:	"重戦車",					movement: 5,	ammo: 8,	vision: 1,	range: 1,	fuel:	50,	cost: 16000,	mtype: "tank" },
		neotank:		{	name:	"新型戦車",				movement: 6,	ammo: 9,	vision: 1,	range: 1,	fuel:	99,	cost: 22000,	mtype: "tank" },
		megatank:		{	name:	"グレートタンク",	movement: 4,	ammo: 3,	vision: 1,	range: 1,	fuel:	50,	cost: 28000,	mtype: "tank" },
		antiair:		{	name:	"対空戦車",				movement: 6,	ammo: 9,	vision: 2,	range: 1,	fuel:	60,	cost: 8000,		mtype: "tank" },
		artillery:	{	name:	"自走砲",					movement: 5,	ammo: 9,	vision: 1,	range: 2,	maxrange: 3,	fuel:	50,	cost: 6000,		mtype: "tank" },
		rocket:			{	name:	"ロケット砲",			movement: 5,	ammo: 6,	vision: 1,	range: 3,	maxrange: 5,	fuel:	50,	cost: 15000,	mtype: "wheel" },
		missle:			{	name:	"対空ミサイル",		movement: 4,	ammo: 6,	vision: 5,	range: 3,	maxrange: 5,	fuel:	50,	cost: 12000,	mtype: "wheel" },
		piperunner:	{	name:	"パイプランナー",	movement: 9,	ammo: 9,	vision: 4,	range: 2,	maxrange: 5,	fuel:	99,	cost: 20000,	mtype: "pipe" },
		tcopter:		{	name:	"輸送ヘリ",				movement: 6,	ammo: 0,	vision: 2,	range: 0,	fuel:	99,	cost: 5000,		mtype: "air",				canload: true },
		bcopter:		{	name:	"戦闘ヘリ",				movement: 6,	ammo: 6,	vision: 3,	range: 1,	fuel:	99,	cost: 9000,		mtype: "air" },
		fighter:		{	name:	"戦闘機",					movement: 9,	ammo: 9,	vision: 2,	range: 1,	fuel:	99,	cost: 20000,	mtype: "air" },
		bomber:			{	name:	"爆撃機",					movement: 7,	ammo: 9,	vision: 2,	range: 1,	fuel:	99,	cost: 22000,	mtype: "air" },
		stealth:		{	name:	"ステルス",				movement: 6,	ammo: 6,	vision: 4,	range: 1,	fuel:	60,	cost: 24000,	mtype: "air",				canstealth: true },
		blackbomb:	{	name:	"ブラックボム",		movement: 9,	ammo: 0,	vision: 1,	range: 0,	fuel:	45,	cost: 25000,	mtype: "air" },
		blackboat:	{	name:	"ブラックボート",	movement: 7,	ammo: 0,	vision: 1,	range: 0,	fuel:	60,	cost: 7500,		mtype: "lander",		cansupply: true,	canload: true },
		lander:			{	name:	"輸送船",					movement: 6,	ammo: 0,	vision: 1,	range: 0,	fuel:	99,	cost: 12000,	mtype: "lander",		canload: true },
		cruiser:		{	name:	"護衛艦",					movement: 6,	ammo: 9,	vision: 3,	range: 1,	fuel:	99,	cost: 18000,	mtype: "ship",			canload: true },
		battleship:	{	name:	"戦艦",						movement: 5,	ammo: 9,	vision: 2,	range: 2,	maxrange: 6,	fuel:	99,	cost: 28000,	mtype: "ship" },
		carrier:		{	name:	"空母",						movement: 5,	ammo: 9,	vision: 4,	range: 3,	maxrange: 8,	fuel:	99,	cost: 30000,	mtype: "ship",	canload: true },
		sub:				{	name:	"潜水艦",					movement: 5,	ammo: 6,	vision: 5,	range: 1,	fuel:	60,	cost: 20000,	mtype: "ship",			canstealth: true },
	};

	let Unit_imglist = {
		infantry:		{ imgdata: { num: 0, ix:  0, iy : 0, height: 16 } },
		mech:				{ imgdata: { num: 0, ix:  5, iy : 0, height: 16 } },
		apc:				{ imgdata: { num: 1, ix:  5, iy : 0, height: 16 } },
		oozium: 		{ imgdata: { num: 1, ix: 11, iy : 0, height: 16 } },
		recon:			{ imgdata: { num: 1, ix:  0, iy : 0, height: 16 } },
		tank:				{ imgdata: { num: 1, ix:  1, iy : 0, height: 16 } },
		mdtank:			{ imgdata: { num: 1, ix:  2, iy : 0, height: 16 } },
		neotank:		{ imgdata: { num: 1, ix:  3, iy : 0, height: 16 } },
		megatank:		{ imgdata: { num: 1, ix:  4, iy : 0, height: 16 } },
		antiair:		{ imgdata: { num: 1, ix:  8, iy : 0, height: 16 } },
		artillery:	{ imgdata: { num: 1, ix:  6, iy : 0, height: 16 } },
		rocket:			{ imgdata: { num: 1, ix:  7, iy : 0, height: 16 } },
		missle:			{ imgdata: { num: 1, ix:  9, iy : 0, height: 16 } },
		piperunner:	{ imgdata: { num: 1, ix: 10, iy : 0, height: 16 } },
		tcopter:		{ imgdata: { num: 2, ix:  3, iy : 0, height: 16 } },
		bcopter:		{ imgdata: { num: 2, ix:  2, iy : 0, height: 16 } },
		fighter:		{ imgdata: { num: 2, ix:  0, iy : 0, height: 16 } },
		bomber:			{ imgdata: { num: 2, ix:  1, iy : 0, height: 16 } },
		stealth:		{ imgdata: { num: 2, ix:  4, iy : 0, height: 16 } },
		blackbomb:	{ imgdata: { num: 2, ix:  5, iy : 0, height: 16 } },
		blackboat:	{ imgdata: { num: 3, ix:  4, iy : 0, height: 16 } },
		lander:			{ imgdata: { num: 3, ix:  2, iy : 0, height: 16 } },
		cruiser:		{ imgdata: { num: 3, ix:  1, iy : 0, height: 16 } },
		battleship:	{ imgdata: { num: 3, ix:  0, iy : 0, height: 16 } },
		carrier:		{ imgdata: { num: 3, ix:  5, iy : 0, height: 16 } },
		sub:				{ imgdata: { num: 3, ix:  3, iy : 0, height: 16 } },
	}

	let TerrainUI_data = [
		{	type: "imgsp",	name:	"plain" },
		{	type: "imgsp",	name:	"plain_pd" },
		{	type: "imgsp",	name:	"wood" },
		{	type: "imgsp",	name:	"mountain" },
		{	type: "imgsp",	name:	"road" },
		{	type: "imgsp",	name:	"bridge" },
		{	type: "imgsp",	name:	"pipe" },
		{	type: "imgsp",	name:	"pipe_c" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"river" },
		{	type: "imgsp",	name:	"sea" },
		{	type: "imgsp",	name:	"reef" },
		{	type: "imgsp",	name:	"shoal" },
		{	type: "imgsp",	name:	"missle" },
		{	type: "imgsp",	name:	"misslenone" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"wideriver" },
		{ type: "newline", y: 10 },
	];

	let Terrain_Land_UI_data = [
		{	type: "imgsp",	name:	"road6" },
		{	type: "imgsp",	name:	"road14" },
		{	type: "imgsp",	name:	"road12" },
		{	type: "imgsp",	name:	"road10" },
		{	type: "imgsp",	name:	"road6s" },
		{	type: "imgsp",	name:	"road14s" },
		{	type: "imgsp",	name:	"road12s" },
		{	type: "imgsp",	name:	"road10s" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"road7" },
		{	type: "imgsp",	name:	"road15" },
		{	type: "imgsp",	name:	"road13" },
		{	type: "imgsp",	name:	"road5" },
		{	type: "imgsp",	name:	"road7s" },
		{	type: "imgsp",	name:	"road15s" },
		{	type: "imgsp",	name:	"road13s" },
		{	type: "imgsp",	name:	"road5s" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"road3" },
		{	type: "imgsp",	name:	"road11" },
		{	type: "imgsp",	name:	"road9" },
		{ type: "space", x: Terrain_UI_width - 3},
		{	type: "imgsp",	name:	"road3s" },
		{	type: "imgsp",	name:	"road11s" },
		{	type: "imgsp",	name:	"road9s" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"pipe4" },
		{	type: "imgsp",	name:	"pipe6" },
		{	type: "imgsp",	name:	"pipe12" },
		{	type: "imgsp",	name:	"pipe_cv" },
		{	type: "imgsp",	name:	"plain_pdv" },
		{	type: "imgsp",	name:	"road6ns" },
		{	type: "imgsp",	name:	"road14ns" },
		{	type: "imgsp",	name:	"road12ns" },
		{	type: "imgsp",	name:	"road10ns" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"pipe5" },
		{	type: "imgsp",	name:	"pipe3" },
		{	type: "imgsp",	name:	"pipe9" },
		{	type: "imgsp",	name:	"pipe_ch" },
		{	type: "imgsp",	name:	"plain_pdh" },
		{	type: "imgsp",	name:	"road7ns" },
		{	type: "imgsp",	name:	"road15ns" },
		{	type: "imgsp",	name:	"road13ns" },
		{	type: "imgsp",	name:	"road5ns" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"pipe1" },
		{	type: "imgsp",	name:	"pipe2" },
		{	type: "imgsp",	name:	"pipe10" },
		{	type: "imgsp",	name:	"pipe8" },
		{ type: "space", x: Terrain_UI_width - 3 },
		{	type: "imgsp",	name:	"road3ns" },
		{	type: "imgsp",	name:	"road11ns" },
		{	type: "imgsp",	name:	"road9ns" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"plains" },
		{	type: "imgsp",	name:	"plainns" },
		{	type: "imgsp",	name:	"woods" },
		{	type: "imgsp",	name:	"woodns" },
		{	type: "imgsp",	name:	"mountain2" },
		{	type: "imgsp",	name:	"mountain3" },
		{	type: "imgsp",	name:	"bridgeh" },
		{	type: "imgsp",	name:	"bridgev" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"mcannon_u" },
		{	type: "imgsp",	name:	"mcannon_r" },
		{	type: "imgsp",	name:	"mcannon_d" },
		{	type: "imgsp",	name:	"mcannon_l" },
		{	type: "imgsp",	name:	"mcannon_all" },
		{	type: "imgsp",	name:	"bstone" },
		{	type: "imgsp",	name:	"mcannon_airl" },
		{ type: "newline" },
	];

	let Terrain_Sea_UI_data = [
		{	type: "imgsp",	name:	"sea9" },
		{	type: "imgsp",	name:	"sea1" },
		{	type: "imgsp",	name:	"sea3" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea33" },
		{	type: "imgsp",	name:	"sea97" },
		{	type: "imgsp",	name:	"sea65" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea8" },
		{	type: "imgsp",	name:	"sea0" },
		{	type: "imgsp",	name:	"sea2" },
		{	type: "imgsp",	name:	"sea40" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea14" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea66" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea12" },
		{	type: "imgsp",	name:	"sea4" },
		{	type: "imgsp",	name:	"sea6" },
		{	type: "imgsp",	name:	"sea56" },
		{	type: "imgsp",	name:	"sea7" },
		{	type: "imgsp",	name:	"sea15" },
		{	type: "imgsp",	name:	"sea13" },
		{	type: "imgsp",	name:	"sea194" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea32" },
		{	type: "imgsp",	name:	"sea96" },
		{	type: "imgsp",	name:	"sea64" },

		{	type: "imgsp",	name:	"sea24" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea11" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea130" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea48" },
		{	type: "imgsp",	name:	"sea240" },
		{	type: "imgsp",	name:	"sea192" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea20" },
		{	type: "imgsp",	name:	"sea148" },
		{	type: "imgsp",	name:	"sea132" },
		{ type: "newline" },


		{	type: "imgsp",	name:	"sea16" },
		{	type: "imgsp",	name:	"sea144" },
		{	type: "imgsp",	name:	"sea128" },

		{	type: "imgsp",	name:	"sea112" },
		{	type: "imgsp",	name:	"sea224" },

		{	type: "imgsp",	name:	"sea41" },
		{	type: "imgsp",	name:	"sea5" },
		{	type: "imgsp",	name:	"sea67" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea_r1" },
		{	type: "imgsp",	name:	"sea_r2" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea176" },
		{	type: "imgsp",	name:	"sea208" },

		{	type: "imgsp",	name:	"sea10" },
		{ type: "space", x: Terrain_UI_width  },
		{	type: "imgsp",	name:	"sea10" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea_r4" },
		{	type: "imgsp",	name:	"sea_r8" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"sea80" },
		{	type: "imgsp",	name:	"sea160" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"sea28" },
		{	type: "imgsp",	name:	"sea5" },
		{	type: "imgsp",	name:	"sea134" },
		{ type: "newline" },
	];

	let Terrain_Shoal_UI_data = [
		{	type: "imgsp",	name:	"shoal89" },
		{	type: "imgsp",	name:	"shoal145" },
		{	type: "imgsp",	name:	"shoal163" },

		{	type: "imgsp",	name:	"shoal25" },
		{	type: "imgsp",	name:	"shoal129" },
		{	type: "imgsp",	name:	"shoal17" },
		{	type: "imgsp",	name:	"shoal131" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal200" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal50" },

		{	type: "imgsp",	name:	"shoal8" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"shoal2" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal172" },
		{	type: "imgsp",	name:	"shoal100" },
		{	type: "imgsp",	name:	"shoal86" },

		{	type: "imgsp",	name:	"shoal44" },
		{	type: "imgsp",	name:	"shoal68" },
		{	type: "imgsp",	name:	"shoal36" },
		{	type: "imgsp",	name:	"shoal70" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal73" },
		{	type: "imgsp",	name:	"shoal1" },
		{	type: "imgsp",	name:	"shoal35" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"shoal11" },
		{ type: "newline" },


		{	type: "imgsp",	name:	"shoal136" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal18" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal9" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal3" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal72" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal34" },

		{	type: "imgsp",	name:	"shoal13" },
		{ type: "space", x: Terrain_UI_width * 3 },
		{	type: "imgsp",	name:	"shoal7" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal140" },
		{	type: "imgsp",	name:	"shoal4" },
		{	type: "imgsp",	name:	"shoal22" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal12" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal6" },
		{ type: "newline" },

		{ type: "space", x: Terrain_UI_width * 5},
		{	type: "imgsp",	name:	"shoal14" },
		{ type: "newline" },
	];

	let Terrain_River_UI_data = [
		{	type: "imgsp",	name:	"river38" },
		{	type: "imgsp",	name:	"river110" },
		{	type: "imgsp",	name:	"river76" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"river10" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"river6" },
		{	type: "imgsp",	name:	"river14" },
		{	type: "imgsp",	name:	"river12" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"river55" },
		{	type: "imgsp",	name:	"river255" },
		{	type: "imgsp",	name:	"river205" },
		{ type: "space", x: Terrain_UI_width * 0.5},
		{	type: "imgsp",	name:	"river5" },
		{ type: "space", x: Terrain_UI_width * 0.5},
		{	type: "imgsp",	name:	"river7" },
		{	type: "imgsp",	name:	"river15" },
		{	type: "imgsp",	name:	"river13" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"river19" },
		{	type: "imgsp",	name:	"river155" },
		{	type: "imgsp",	name:	"river137" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"river3" },
		{	type: "imgsp",	name:	"river11" },
		{	type: "imgsp",	name:	"river9" },
		{ type: "newline", y: 15 },

		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"river46" },
		{	type: "imgsp",	name:	"river78" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"river39" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"river77" },
		{ type: "newline" },


		{	type: "imgsp",	name:	"river23" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"river141" },
		{ type: "newline" },

		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"river27" },
		{	type: "imgsp",	name:	"river139" },
		{ type: "newline" },

	];

	let UnitUI_data = {
		no: [
			{ type: "imgsp2",		name: "infantry" },
			{ type: "imgsp2",		name: "mech" },
			{ type: "imgsp2",		name: "apc" },
			{ type: "imgsp2",		name: "oozium" },
			{ type: "space",	x: Terrain_UI_width },
			{ type: "img",		name: "delete",	fiximage: true, src: path + "image/icon/hammer.png" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "recon" },
			{ type: "imgsp2",		name: "tank" },
			{ type: "imgsp2",		name: "mdtank" },
			{ type: "imgsp2",		name: "neotank" },
			{ type: "imgsp2",		name: "megatank" },
			{ type: "imgsp2",		name: "antiair" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "artillery" },
			{ type: "imgsp2",		name: "rocket" },
			{ type: "imgsp2",		name: "missle" },
			{ type: "imgsp2",		name: "piperunner" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "tcopter" },
			{ type: "imgsp2",		name: "bcopter" },
			{ type: "imgsp2",		name: "fighter" },
			{ type: "imgsp2",		name: "bomber" },
			{ type: "imgsp2",		name: "stealth" },
			{ type: "imgsp2",		name: "blackbomb" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "blackboat" },
			{ type: "imgsp2",		name: "lander" },
			{ type: "imgsp2",		name: "cruiser" },
			{ type: "imgsp2",		name: "battleship" },
			{ type: "imgsp2",		name: "carrier" },
			{ type: "imgsp2",		name: "sub" },
		]
	};

	for (let i = 0 ; i < Country.length ; i++) {
		TerrainUI_data.push({ type: "space", x: Terrain_UI_width });
		let c = Country[i];
		for (let bname in Buildinglist) {
			let b = Buildinglist[bname];
			if (b.hq && c.npc) {
				TerrainUI_data.push({ type: "space", x: Terrain_UI_width });
				continue;
			}
			let cname = c.fname;
			let t = Terrain_imglist[bname + "_" + cname] = copyobject(b);
			t.country = c.fname;
			t.countrynum = i;
			t.name += "_" + c.fname;
			t.building = true;
			let t2 = Terrain[bname + "_" + cname] = copyobject(Terrain[bname]);
			t2.imgdata.ix += i;
			if (bname == "hq") {
				t.imgdata.ix = i;
				t.imgdata.iy = (i - 1) * 2;
				TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
			}
			else {
				t.imgdata.ix += i;
				TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
			}
		}

		TerrainUI_data.push({ type: "newline" });

		if (!c.npc) {
			let udata = UnitUI_data[c.fname] = [];
			for (let j = 0 ; j < UnitUI_data["no"].length ; j++) {
				let u = copyobject(UnitUI_data["no"][j]);
				if (u.name !== undefined && u.name !== "delete") {
					let name = u.name + "_" + c.fname;
					Unit_imglist[name] = copyobject(Unit_imglist[u.name]);
					Unit_imglist[name].imgdata.iy += i - 1;
					Unit_imglist[name].country = c.fname;
					Unit_imglist[name].uname = u.name;
					u.name += "_" + c.fname;
				}
				else if (u.name === "delete") {
					u.name += "_" + c.fname;
				}
				udata.push(u);
			}
		}
	}

	for (let bname in LargeBuildinglist) {
		let b = LargeBuildinglist[bname];
		Terrain_imglist[bname] = copyobject(b);
		for (let x = 0 ; x < b.size ; x++) {
			for (let y = 0 ; y < b.size ; y++) {
				let t = Terrain_imglist[bname + x + "" + y] = copyobject(b);
				t.imgdata.ix += x;
				t.imgdata.iy += y;
				t.imgdata.x = x;
				t.imgdata.y = y;
				t.imgdata.height = 16;
				if (x == t.destroyx && y == t.destroyy) {
					t.name += "d";
				}
			}
		}
		Terrain_Land_UI_data.push({ type: "imgsp", name: bname });
	}

	let Maptype = [
		{ fname: "normal" },
		{ fname: "wasteland" },
		{ fname: "desert" },
		{ fname: "snow" },
	];

	function getmyid() {
		idcount++;
		return idcount;
	}

	function copyobject(obj) {
		if (typeof obj != "object") {
			return obj;
		}
		let type = Object.prototype.toString.call(obj);
		if (type == "[object Object]") {
			let retval = {};
			for (let p in obj) {
				retval[p] = copyobject(obj[p]);
			}
			return retval;
		}
		else if (type == "[object Array]") {
			let retval = [];
			for (let i = 0 ; i < obj.length ; i++) {
				retval[i] = copyobject(obj[i]);
			}
			return retval;
		}
		else {
			return obj;
		}
	}

	function FWEditor(canvasid, path) {
		let id = getmyid();
		path = (path !== undefined) ? path : "";

		this.terrainimg = [];
		for (let i = 0 ; i < 5 ; i++) {
			this.terrainimg[i] = [];
			for (let k = 0 ; k < Maptype.length ; k++) {
				this.terrainimg[i][k] = new Image();
 				this.terrainimg[i][k].src = path + "image/terrain/" + Maptype[k].fname + "/images" + i + ".png";
			}
		}

		this.unitimg = [];
		for (let i = 0 ; i < 4 ; i++) {
			this.unitimg[i] = new Image();
			this.unitimg[i].src = path + "image/unit/images" + i + ".png";
		}

		this.numimg = [];
		this.hpimg = [];
		for (let i = 0 ; i < 10 ; i++) {
			this.hpimg[i] = new Image();
			this.hpimg[i].src = path + "image/icon/HP" + i + ".png";
			this.numimg[i] = new Image();
			this.numimg[i].src = path + "image/icon/num" + i + ".png";
		}

		this.terraininfoimg = new Image();
		this.terraininfoimg.src = path + "image/other/terraininfo.png";
		this.terraininforimg = new Image();
		this.terraininforimg.src = path + "image/other/terraininfor.png";
		this.terrainandunitinfoimg = new Image();
		this.terrainandunitinfoimg.src = path + "image/other/terrainandunitinfo.png";
		this.terrainandunitinforimg = new Image();
		this.terrainandunitinforimg.src = path + "image/other/terrainandunitinfor.png";

		this.cannotenterimg = new Image();
		this.cannotenterimg.src = path + "image/terrain/cannotenter.png";

		this.hammerimg = new Image();
		this.hammerimg.src = path + "image/icon/hammer.png";
		this.productimg = new Image();
		this.productimg.src = path + "image/icon/product.png";

		this.starimg = new Image();
		this.starimg.src = path + "image/icon/star.png";

		this.capturehpimg = new Image();
		this.capturehpimg.src = path + "image/icon/capturehp.png";

		this.lifeimg = new Image();
		this.lifeimg.src = path + "image/icon/life.png";

		this.lifeunitimg = new Image();
		this.lifeunitimg.src = path + "image/icon/lifeunit.png";
		this.fuelunitimg = new Image();
		this.fuelunitimg.src = path + "image/icon/fuel.png";
		this.bulletimg = new Image();
		this.bulletimg.src = path + "image/icon/bullet.png";

		this.cursorimg = new Image();
		this.cursorimg.src = path + "image/icon/cursor.png";
		this.cursorimg2 = new Image();
		this.cursorimg2.src = path + "image/icon/cursor2.png";
		this.cursorimg3 = new Image();
		this.cursorimg3.src = path + "image/icon/cursor3.png";

		this.cursorarrowimg = [];
		for (let i = 0 ; i < 4 ; i++) {
			this.cursorarrowimg[i] = new Image();
			this.cursorarrowimg[i].src = path + "image/icon/cursorarrow" + i + ".png";
		}

		this.ammoimg = {};
		this.fuelimg = {};
		this.captureimg = {};
		this.loadimg = {};
		this.stealthimg = {};
		this.defenceimg;
		for (let i = 1 ; i < Country.length ; i++) {
			let cname = Country[i].fname;
			this.ammoimg[cname] = new Image();
			this.ammoimg[cname].src = path + "image/icon/Bullet_" + cname.toUpperCase() + ".png";
			this.fuelimg[cname] = new Image();
			this.fuelimg[cname].src = path + "image/icon/Fuel_" + cname.toUpperCase() + ".png";
			this.captureimg[cname] = new Image();
			this.captureimg[cname].src = path + "image/icon/Capture_" + cname.toUpperCase() + ".png";
			this.loadimg[cname] = new Image();
			this.loadimg[cname].src = path + "image/icon/Load_" + cname.toUpperCase() + ".png";
			this.stealthimg[cname] = new Image();
			this.stealthimg[cname].src = path + "image/icon/Dive_" + cname.toUpperCase() + ".png";
		}
		this.defenceimg = new Image();
		this.defenceimg.src = path + "image/icon/Defence.png";

		this.changesizeimg = new Image();
		this.changesizeimg.src = path + "image/button/changesize.png";

		this.resizedrag = false;

		this.savedata = {
			fwmapdataver:	2,
			mapdata: {},
			countrydata: {},
		};

		this.canvas = document.getElementById(canvasid);
		this.canvas.me = this;
		if (!this.canvas || !this.canvas.getContext) {
			this.canuse = false;
			return;
 		}
		this.canuse = true;
		this.ctx = this.canvas.getContext('2d');

		this.canvas.canvasmousemove = function(evt) {
			let me = this.me;
			let rect = this.getBoundingClientRect();
			let mx, my;
			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);
			let dragx = me.dragx;
			let dragy = me.dragy;
			if (me.usetool) {
				let cx = Math.floor(mx / Sqsize);
				let cy = Math.floor(my / Sqsize);
				if (me.select_mode === "Terrain") {
					if (evt.buttons & 1) {
						me.setmap(cx, cy, me.select_terrain);
						me.countbuilding();
					}
					else if (evt.buttons & 2) {
						let fromx = (cx < dragx) ? cx : dragx;
						let fromy = (cy < dragy) ? cy : dragy;
						let tox = (cx > dragx) ? cx : dragx;
						let toy = (cy > dragy) ? cy : dragy;
						let tname = me.select_terrain;
						let t = Terrain_imglist[tname];
						let plus = (t.large) ? t.size : 1;
						me.restoremap();
						for (let x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (let y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, tname);
								me.countbuilding();
							}
						}
					}
				}
				else if (me.select_mode === "Unit") {
					if (evt.buttons & 1) {
						let c = me.select_unitcountry;
						let u = me.select_unit;
						let selunit = me.findunit(cx, cy);
						if (selunit !== false && (u.substr(0, 6) === "delete" || me.select_unitlock !== "lock")) {
							if (u.substr(0, 6) === "delete" || !me.savedata.mapdata.unitlimit || (me.unitcountrycount[c] + ((selunit.udata.country === c) ? 0 : 1) <= 50)) {
								me.unitcountrycount[selunit.udata.country]--;
								me.deleteunit(selunit.country, selunit.index);
							}
						}
						if (u.substr(0, 6) !== "delete" && me.findunit(cx, cy) === false) {
							if (!me.savedata.mapdata.unitlimit || me.unitcountrycount[c] < 50) {
								me.setunit(cx, cy, c, u);
							}
						}
						me.setunitmap();
					}
					else if (evt.buttons & 2) {
						let selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunitmap();
					}
				}
				else if (me.select_mode == "Map") {
					if (me.resizedrag) {
						let w = Math.floor(mx / Sqsize) + 1;
						let h = Math.floor(my / Sqsize) + 1;
						if (!(w <= 0 || w > Maxwidth || h <= 0 || h > Maxheight)) {
							if (me.savedata.mapdata.width != w || me.savedata.mapdata.height != h) {
								me.init(w, h, false);
							}
						}
					}
				}
			}
			me.draw();
		}
		this.canvas.addEventListener("mousemove", this.canvas.canvasmousemove);
		this.canvas.addEventListener("mousedown", function(evt) {
			let rect = this.getBoundingClientRect();
			let me = this.me;
			let map = me.savedata.mapdata.map;
			let tx = me.tx;
			let ty = me.ty;
			let mx, my;

			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);

			if (me.usetool) {
				let cx = Math.floor(mx / Sqsize);
				let cy = Math.floor(my / Sqsize);

				if (me.select_mode === "Terrain") {
					if (evt.buttons & 2) {
						me.backupmap();
						me.dragx = Math.floor(mx / Sqsize);
						me.dragy = Math.floor(my / Sqsize);
					}
				}
				else if (me.select_mode == "Map") {
					let r = UI_Rect(me.maprect.w - 0.5 * Sqsize, me.maprect.h - 0.5 * Sqsize, Sqsize, Sqsize);
					if (r.isinside(mx, my)) {
						me.resizedrag = true;
					}
				}
				if (me.select_mode === "Map" || me.select_mode === "UEdit" || me.select_mode === "CEdit" || me.select_mode === "Config") {
					if (me.isinside(cx, cy)) {
						if (evt.buttons & 1) {
							me.savedata.mapdata.cx = cx;
							me.savedata.mapdata.cy = cy;
							me.select_edit_unit = me.findunit(cx, cy);
							me.savedata.mapdata.selectunit = me.select_edit_unit ? true : false;
						}
						else if (evt.buttons & 2) {
							me.savedata.mapdata.cx = cx;
							me.savedata.mapdata.cy = cy;
							me.select_edit_unit = null;
							me.savedata.mapdata.selectunit = false;
						}
					}
				}

				this.canvasmousemove(evt);
				me.draw();
			}
		});
		this.canvas.addEventListener("mouseup", function(evt) {
			let me = this.me;
			let rect = this.getBoundingClientRect();
			me.mx = Math.floor(evt.clientX - rect.left);
			me.my = Math.floor(evt.clientY - rect.top);
			this.me.resizedrag = false;
			me.draw();
		});
		this.canvas.addEventListener("mouseout", function(evt) {
			let me = this.me;
			me.resizedrag = false;
			me.draw();
		});
		this.canvas.addEventListener("contextmenu", function(evt) {
			let rect = this.getBoundingClientRect();
			let mx = Math.floor(evt.clientX - rect.left);
			let my = Math.floor(evt.clientY - rect.top);
			if (this.me.maprect.isinside(mx, my)) {
				evt.preventDefault();
				evt.returnValut = false;
			}
		});
	
		this.canvas.addEventListener("wheel", function(evt) {
			evt.preventDefault();
			evt.returnValut = false;
		});

		this.usetool = true;

		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: this.savedata.mapdata.width, height: this.savedata.mapdata.height }
		};
		this.setsize = function(w, h, clear) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			let newmap = [];
			let newmaphp = [];
			this.mapbeforedrag = [];
			for (let x = 0 ; x < w ; x++) {
				newmap[x] = [];
				newmaphp[x] = [];
				this.mapbeforedrag[x] = [];
				for (let y = 0 ; y < h ; y++) {
					if (!clear && this.savedata.mapdata.map[x] !== undefined && this.savedata.mapdata.map[x][y] !== undefined) {
						newmap[x][y] = this.savedata.mapdata.map[x][y];
						if (this.savedata.mapdata.maphp !== undefined) {
							newmaphp[x][y] = this.savedata.mapdata.maphp[x][y];
						}
						else {
							newmaphp[x][y] = 99;
						}
					}
					else {
						newmap[x][y] = "plain";
						newmaphp[x][y] = 99;
					}
					this.mapbeforedrag[x][y] = 0;
				}
			}
			this.savedata.mapdata.map = newmap;
			this.savedata.mapdata.maphp = newmaphp;
			this.savedata.mapdata.cx = 0;
			this.savedata.mapdata.cy = 0;
			this.savedata.mapdata.selectunit = false;
			this.select_edit_unit = null;

			if (clear) {
				for (let i = 0 ; i < Country.length ; i++) {
					let c = Country[i];
					if (c.npc) {
						continue;
					}
					let cdata = this.savedata.countrydata[c.fname];
					cdata.front.shogun = null;
					cdata.front.bp = 0;
					cdata.back.shogun = null;
					cdata.back.bp = 0;
					cdata.money = 0;
					cdata.unitdirection = "normal";
					cdata.unitcountrytype = c.fname;
					cdata.unitdata = [];
				}
			}
			else {
				for (let i = 0 ; i < Country.length ; i++) {
					let c = Country[i];
					if (c.npc) {
						continue;
					}
					let u = this.savedata.countrydata[c.fname].unitdata;
					for (let j = 0 ; j < u.length ; j++) {
						if (!(u[j].x < w && u[j].y < h)) {
							u.splice(j, 1);
							j--;
						}
					}
				}
			}
			this.savedata.mapdata.width = w;
			this.savedata.mapdata.height = h;
			this.maprect = UI_Rect(0, 0, w * Sqsize, h * Sqsize);
			this.setunitmap();
		}

		this.findunit = function(x, y) {
			for (let i = 0 ; i < Country.length ; i++) {
				let c = Country[i];
				if (c.npc) {
					continue;
				}
				let udata = this.savedata.countrydata[c.fname].unitdata;
				for (let j = 0 ; j < udata.length ; j++) {
					let u = udata[j];
					if (u.x == x && u.y == y) {
						return { country: c.fname, index: j, udata: udata[j] };
					}
				}
			}
			return false;
		}

		this.setunit = function(x, y, cname, uname) {
			if (this.isinside(x, y)) {
				this.savedata.countrydata[cname].unitdata.push({ x: x, y: y, fname: uname });
				this.checkunitdata();
			}
		}	

		this.deleteunit = function(cname, index) {
			if (!this.savedata.countrydata[cname].unitdata) {
				return;
			}
			this.savedata.countrydata[cname].unitdata.splice(index, 1);
		}

		this.checkconfigdata = function() {
			if (this.savedata.config === undefined) {
				this.savedata.config = {};
			}
			if (this.savedata.config.animation === undefined) {
				this.savedata.config.animation = true;
			}
			if (this.savedata.config.displayterrainnum === undefined) {
				this.savedata.config.displayterrainnum = true;
			}
			if (this.savedata.config.displayterrainandunitinfo === undefined) {
				this.savedata.config.displayterrainandunitinfo = true;
			}
		}

		this.checkmapdata = function() {
			if (this.savedata.mapdata.buildinglimit === undefined) {
				this.savedata.mapdata.buildinglimit = false;
			}
			if (this.savedata.mapdata.unitlimit === undefined) {
				this.savedata.mapdata.unitlimit = false;
			}
		}

		this.checkunitdata = function() {
			for (let i = 0 ; i < Country.length ; i++) {
				let c = Country[i];
				if (c.npc) {
					continue;
				}
				let udata = this.savedata.countrydata[c.fname].unitdata;
				for (let j = 0 ; j < udata.length ; j++) {
					let u = udata[j];
					u.uname = u.fname.slice(0, -3);
					u.country = u.fname.slice(-2);
					u.countrynum = Countrynamenum[u.country];
					let unit = Unit[u.uname];
					if (u.hp === undefined) {
						u.hp = 10;
					}
					if (u.ammo === undefined) {
						u.ammo = unit.ammo;
					}
					if (u.fuel === undefined) {
						u.fuel = unit.fuel;
					}
					if (u.capture === undefined && unit.cancapture) {
						u.capture = false;
					}
					if (u.load === undefined && unit.canload) {
						u.load = false;
					}
					if (u.stealth === undefined && unit.canstealth) {
						u.stealth = false;
					}
					if (u.defence === undefined) {
						u.defence = false;
					}
					if (u.capturenum === undefined) {
						u.capturenum = 10;
					}
				}
			}
		}

		this.unitcountrycount = {};
		this.unitcount = {};
		this.setunitmap = function() {
			for (let i = 1 ; i < Country.length ; i++) {
				this.unitcountrycount[Country[i].fname] = 0;
			}
			for (let uname in Unit_imglist) {
				this.unitcount[uname] = 0;
			}
			let unitmap = this.unitmap = [];
			for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
				unitmap[x] = [];
				for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
					unitmap[x][y] = null;
				}
			}
			for (let i = 0 ; i < Country.length ; i++) {
				let c = Country[i];
				if (c.npc) {
					continue;
				}
				let udata = this.savedata.countrydata[c.fname].unitdata;
				for (let j = 0 ; j < udata.length ; j++) {
					let u = udata[j];
					unitmap[u.x][u.y] = u;
					this.unitcountrycount[Country[i].fname]++;
					this.unitcount[u.fname]++;
				}
			}
		}

		this.drawterrain = function(tname, dx, dy, x, y, c) {
			let ctx = this.ctx;
			let map = this.savedata.mapdata.map;
			let t = Terrain_imglist[tname];
			let t2;
			if (t.connect && c !== null) {
				if (tname == "wideriver") {
					t2 = Terrain_imglist["river" + c];
				}
				else {
					t2 = Terrain_imglist[tname + c];
				}
			}
			else {
				t2 = t;
			}
			if (x > 0 && t2.receiveshadow && Terrain_imglist[map[x - 1][y]].shadow) {
				ctx.drawImage(this.terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.sx * Sqsize, t2.imgdata.sy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
			}
			else {
				if (t2.large) {
					ctx.drawImage(this.terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, t2.imgdata.height, t2.imgdata.height, dx, dy, Sqsize, Sqsize);
				}
				else {
					ctx.drawImage(this.terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
				}
			}
		}

		this.drawunit = function(unit, dx, dy, reversex) {
			let ctx = this.ctx;
			let u = Unit_imglist[unit.fname];
			if (reversex) {
				ctx.save();
				ctx.scale(-1, 1);
				ctx.drawImage(this.unitimg[u.imgdata.num], u.imgdata.ix * Sqsize, u.imgdata.iy * Sqsize, Sqsize, Sqsize, -dx -Sqsize, dy, Sqsize, Sqsize);
				ctx.restore();
			}
			else {
				ctx.drawImage(this.unitimg[u.imgdata.num], u.imgdata.ix * Sqsize, u.imgdata.iy * Sqsize, Sqsize, Sqsize, dx, dy, Sqsize, Sqsize);
			}
		}

		this.drawunitstatus = function(unit, dx, dy) {
			let ctx = this.ctx;
			let udata = Unit[unit.uname];
			let cname = unit.fname.substr(-2, 2);
			let fuelorammo = false;
			let notfuelorammo = false;
			if (unit.hp != 10) {
				ctx.drawImage(this.hpimg[unit.hp], dx + 8, dy + 9, 8, 7);
			}
			
			let statusnum = 0;
			if (udata.ammo > 0 && unit.ammo <= udata.ammo / 2) {
				fuelorammo = true;
				statusnum++;
			}
			if (udata.fuel > 0 && unit.fuel <= udata.fuel / 2) {
				fuelorammo = true;
				statusnum++;
			}
			if (unit.capture) {
				notfuelorammo = true;
				statusnum += 2;
			}
			if (unit.load) {
				notfuelorammo = true;
				statusnum += 2;
			}
			if (unit.stealth) {
				notfuelorammo = true;
				statusnum += 2;
			}
			if (unit.defence) {
				notfuelorammo = true;
				statusnum += 2;
			}

			let acounter = Math.floor(this.animcounter / 10) % (statusnum + ((fuelorammo && !notfuelorammo) ? 1 : 0));
			statusnum = 0;
			let animflag = this.savedata.config.animation;
			if (udata.ammo > 0 && unit.ammo <= udata.ammo / 2) {
				if (!animflag || acounter == statusnum) {
					ctx.drawImage(this.ammoimg[cname], dx, dy + 8, 8, 8);
				}
				statusnum++;
			}
			if (udata.fuel > 0 && unit.fuel <= udata.fuel / 2) {
				if (!animflag || acounter == statusnum) {
					ctx.drawImage(this.fuelimg[cname], dx, dy + 8, 8, 8);
				}
				statusnum++;
			}
			if (unit.capture) {
				if (!animflag || acounter == statusnum || acounter == statusnum + 1) {
					ctx.drawImage(this.captureimg[cname], dx, dy + 8, 8, 8);
				}
				statusnum += 2;
			}
			if (unit.load) {
				if (!animflag || acounter == statusnum || acounter == statusnum + 1) {
					ctx.drawImage(this.loadimg[cname], dx, dy + 8, 8, 8);
				}
				statusnum += 2;
			}
			if (unit.stealth) {
				if (!animflag || acounter == statusnum || acounter == statusnum + 1) {
					ctx.drawImage(this.stealthimg[cname], dx, dy + 8, 8, 8);
				}
				statusnum += 2;
			}
			if (unit.defence) {
				if (!animflag || acounter == statusnum || acounter == statusnum + 1) {
					ctx.drawImage(this.defenceimg, dx, dy + 8, 8, 8);
				}
				statusnum += 2;
			}
		}

		this.drawmap = function() {
			let ctx = this.ctx;
			let map = this.savedata.mapdata.map;
			let smode = this.select_mode;

			ctx.save();
			ctx.beginPath();
			ctx.rect(this.maprect.x, this.maprect.y, this.maprect.w, this.maprect.h);
			ctx.clip();
			for (let i = 1 ; i < Country.length ; i++) {
				let c = Country[i];
				let cnum = Countrynamenum[this.savedata.countrydata[c.fname].unitcountrytype];
				Terrain_imglist["hq_" + c.fname].imgdata.iy = cnum * 2;
				Unit_imglist["infantry_" + c.fname].imgdata.ix = Unit_imglist["infantry"].imgdata.ix + cnum;
				Unit_imglist["mech_" + c.fname].imgdata.ix = Unit_imglist["mech"].imgdata.ix + cnum;
			}

			for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
				for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
					let tname = map[x][y];
					let t = Terrain_imglist[tname];
					let img;
					let c = 0;
					if (t.connect) {
						let count = 0;
						let dx = [ 0, 1, 0, -1 ];
						let dy = [ -1, 0, 1, 0 ];
						let di = [ 1, 3, 0, 2 ];
						let isshoal = [];
						for (let i = 0 ; i < 4 ; i++) {
							let x2 = x + dx[di[i]];
							let y2 = y + dy[di[i]];
							isshoal[di[i]] = false;
							if (this.isinside(x2, y2)) {
								let tname2 = map[x2][y2];
								let t2 = Terrain_imglist[tname2];
								if (tname2 == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((tname == "road" && tname2 == "road") || 
										(tname == "bridge" && (tname2 == "bridge" || t2.land == true)) ||
										(tname == "river" && tname2 == "river") ||
										(tname == "wideriver" && (tname2 == "wideriver" || t2.sea)) ||
										(tname == "sea" && t2.land == true) ||
										(tname == "shoal" && t2.land == true && (tname2 != "river" && tname2 != "wideriver")) ||
										(t.pipe == true && t2.pipe == true && !(tname == "plain_pd" && tname2 == "plain_pd"))) {
									if (i >= 4) {
										if (tname == "river") {
											if (c & (1 << (i % 4)) || c & (1 << (i + 1) % 4)) {
												continue;
											}
										}
									}
									c += (1 << di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (tname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = "h";
									}
									else if (c == 5) {
										c = "v";
									}
									else if (tname == "pipe_c") {
										map[x][y] = "pipe";
										tname = "pipe";
										t = Terrain_imglist["pipe"];
									}
									else if (tname == "plain_pd") {
										c = "";
									}
									break;
								}
							}
						}
						if (count == 0 && tname == "pipe") {
							c = 10;
						}
						if (count <= 1 && tname == "road") {
							if (c == 1 || c == 4) {
								c = 5;
							}
							else {
								c = 10;
							}
						}
						if (tname == "river" || tname == "wideriver" || tname == "sea") {
							if (tname == "river" || tname == "wideriver") {
								if (c == 0) {
									c = 10;
								}
								else if (count == 1) {
									if (c == 1 || c == 4) {
										c = 5;
									}
									else {
										c = 10;
									}
								}
							}
							if (!((tname == "river" || tname == "wideriver") && (c == 5 || c == 10))) {
								let dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
								let dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
								let island = [];
								let isriver = [];
								let issameriver = [];
								let ismouthriver = [];
								let issea = [];
								for (let i = 0 ; i < 8 ; i++) {
									let x2 = x + dx[i];
									let y2 = y + dy[i];
									island[i] = isriver[i] = issameriver[i] = ismouthriver[i] = issea[i] = false;
									if (this.isinside(x2, y2)) {
										let tname2 = map[x2][y2];
										let t2 = Terrain_imglist[tname2];
										if (t2.land == true) {
											island[i] = true;
										}
										if (t2.sea == true) {
											issea[i] = true;
										}
										if ((tname2 == "river" || tname2 == "wideriver") && (tname == "sea" || tname == tname2)) {
											if (tname2 == "river") {
												isriver[i] = true;
											}
											if (tname == tname2) {
												issameriver[i] = true;
											}
											if (tname2 != "wideriver" && (i == 0 || i == 4)) {
												y2 += dy[i];
												if (this.isinside(x2, y2) && map[x2][y2] == "river") {
													ismouthriver[i] = true;
												}
											}
											else {
												ismouthriver[i] = true;
											}
										}
									}
								}
								for (let i = 0 ; i < 8 ; i += 2) {
									if (tname == "sea" && ismouthriver[i] && (!isriver[i] || (!isriver[(i + 7) % 8] && !isriver[(i + 1) % 8])) && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
										c = "_r" + (1 << (i / 2));
										break;
									}
									if ((tname == "sea" && !island[i] && island[(i + 1) % 8] && !island[(i + 2) % 8]) ||
											((tname == "river" || tname =="wideriver") && issameriver[i] && (!issameriver[(i + 1) % 8] && !(tname == "wideriver" && issea[(i + 1) % 8])) && issameriver[(i + 2) % 8])) {
										c |= 1 << ((i / 2) + 4);
									}
								}
							}
						}
						if (count < 2 && tname == "pipe_c") {
							map[x][y] = "pipe";
							tname = "pipe";
							t = Terrain_imglist["pipe"];
							c = 10;
						}
						if (tname == "plain_pd" && count != 2) {
								c = "";
						}
						if (tname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = "v";
							}
							else {
								c = "h";
							}
						}
						if (tname == "wideriver") {
							if (count == 4 && c != 255) {
								c = 15;
							}
						}
						if (tname == "shoal") {
							let dx = [ 1, 1, -1, -1 ];
							let dy = [ -1, 1, 1, -1 ];
							let island = [];
							for (let i = 0 ; i < 4 ; i++) {
								let x2 = x + dx[i];
								let y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							let seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (let i = 0 ; i < 4 ; i++) {
								if (c == 1 << i && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = "sea";
								t = Terrain_imglist["sea"];
								tname = "sea";
							}
							else {
								for (let i = 0 ; i < 4 ; i++) {
									if (c == 7 || c == 11 || c == 13 || c == 14) {
										continue;
									}
									if (c & (1 << i)) {
										if (isshoal[(i + 1) % 4] == true) {
											c |= 1 << (i + 4);
										}
										if (isshoal[(i + 3) % 4] == true) {
											c |= 1 << ((i + 3) % 4 + 4);
										}
									}
								}		
							}
						}
					}
					this.drawterrain(tname, x * Sqsize, y * Sqsize, x, y, c);

					let unit = this.unitmap[x][y];
					if (unit !== null) {
						this.drawunit(unit, x * Sqsize, y * Sqsize, this.savedata.countrydata[Unit_imglist[unit.fname].country].unitdirection === "reverse");
					}
				}
			}

			for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
				for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
					let unit = this.unitmap[x][y];
					if (unit !== null) {
						this.drawunitstatus(unit, x * Sqsize, y * Sqsize);
					}
				}
			}

			if (smode == "Map" && this.resizedrag == true) {
				ctx.beginPath();
				ctx.strokeStyle = "black";
				ctx.lineWidth = 1;
				ctx.rect(this.maprect.x, this.maprect.y, this.maprect.w, this.maprect.h);
				ctx.stroke();
			}
			if (smode === "UEdit" && this.select_edit_unit) {
				var udata = this.select_edit_unit.udata;
				let maxx = this.maprect.w;
				let maxy = this.maprect.h;
				ctx.save();
				ctx.beginPath();
				ctx.moveTo(0, 0);
				ctx.lineTo(maxx, 0);
				ctx.lineTo(udata.x * Sqsize, udata.y * Sqsize);
				ctx.lineTo(udata.x * Sqsize, (udata.y + 1) * Sqsize);
				ctx.lineTo((udata.x + 1) * Sqsize, (udata.y + 1) * Sqsize);
				ctx.lineTo((udata.x + 1) * Sqsize, udata.y * Sqsize);
				ctx.lineTo(udata.x * Sqsize, udata.y * Sqsize);
				ctx.lineTo(maxx, 0);
				ctx.lineTo(maxx, maxy);
				ctx.lineTo(0, maxy);
				ctx.closePath();
				ctx.clip();
				ctx.beginPath();
				ctx.fillStyle = "rgba(0, 0, 0, 0.3)";
				ctx.rect(this.maprect.x, this.maprect.y, this.maprect.w, this.maprect.h);
				ctx.fill();
				ctx.restore();
			}

			let cx = Math.floor(this.mx / Sqsize);
			let cy = Math.floor(this.my / Sqsize);
			if (smode == "Map" || smode === "UEdit" || smode == "CEdit" || smode == "Config") {
				cx = this.savedata.mapdata.cx;
				cy = this.savedata.mapdata.cy;
				if (cy >= this.savedata.mapdata.height - 9) {
					if (cx >= this.savedata.mapdata.width / 2) {
						this.tinfopos = "left";
					}
					else {
						this.tinfopos = "right";
					}
				}
				if (this.savedata.config.displayterrainandunitinfo) {
					let cunit = this.findunit(cx, cy);
					let tx = this.maprect.x + this.maprect.w - 41;
					let ty = this.maprect.y + this.maprect.h - 61;
					let x = tx + 11;
					let y = ty;
					let ux = x - 33;
					let uy = ty;
					if (this.tinfopos === "left") {
						tx = this.maprect.x;
						x = tx + 7;
						ux = x + 31;
					}
					else if (cunit) {
						tx -= 36;
					}
					if (cunit) {
						ctx.drawImage(this.tinfopos === "left" ? this.terrainandunitinforimg : this.terrainandunitinfoimg, tx, ty);
					}
					else {
						ctx.drawImage(this.tinfopos === "left" ? this.terraininforimg : this.terraininfoimg, tx, ty);
					}
					let t = Terrain[Terrain_imglist[map[cx][cy]].name];
					if (t.cannotenter) {
						ctx.drawImage(this.cannotenterimg, t.imgdata.ix * Sqsize, t.imgdata.iy * Sqsize, Sqsize, Sqsize, x + 4, y + 14, Sqsize, Sqsize);
					}
					else if (t.imgdata.large) {
						ctx.drawImage(this.terrainimg[t.imgdata.num][0], t.imgdata.ix * Sqsize + (t.imgdata.height - 32) / 2, t.imgdata.iy * Sqsize + t.imgdata.height - 32, 32, 32, x + 4, y + 14, Sqsize, Sqsize);
					}
					else {
						ctx.drawImage(this.terrainimg[t.imgdata.num][0], t.imgdata.ix * Sqsize, t.imgdata.iy * Sqsize, Sqsize, t.imgdata.height, x + 4, y + 14 + Sqsize - t.imgdata.height, Sqsize, t.imgdata.height);
					}
					ctx.drawImage(this.starimg, x, y + 31);
					ctx.drawImage(this.numimg[t.defence], x + 17, y + 33);
					ctx.font = "700 12px ＭＳ 明朝, sans serif";
					let twidth = ctx.measureText(t.name).width;
					ctx.lineWidth = 0.1;
					let dx = 12 - twidth / 2;
					ctx.save();
					ctx.translate(x + 12, 0);
					ctx.scale(t.name.length > 3 ? 0.9 - t.name.length / 10 : 0.7, 1);
					ctx.translate(-(x + 12) , 0);
					for (let i = 0 ; i < t.name.length ; i++) {
						ctx.fillStyle = "black";
						ctx.font = "900 12px ＭＳ 明朝, sans serif";
						ctx.fillText(t.name.substr(i, 1), Math.floor(x + dx), y + 16);
						let tw = ctx.measureText(t.name.substr(i, 1)).width;
						ctx.font = "12px ＭＳ 明朝, sans serif";
						ctx.fillStyle = "white";
						ctx.fillText(t.name.substr(i, 1), Math.floor(x + dx + 0.5), y + 16);
						dx += tw;
					}
					ctx.restore();
					if (t.building) {
						let unit = this.unitmap[cx][cy];
						ctx.drawImage(this.capturehpimg, x, y + 41);
						let bhp = 20;
						if (unit && unit.capture) {
							bhp = unit.capturenum;
						}
						if (bhp >= 10 && (!this.savedata.config.animation || bhp == 20 || this.animcounter % 8 < 4)) {
							ctx.drawImage(this.numimg[Math.floor(bhp / 10)], x + 10, y + 44);
						}
						if (!this.savedata.config.animation || bhp == 20 || this.animcounter % 8 < 4) {
							ctx.drawImage(this.numimg[bhp % 10], x + 17, y + 44);
						}
					}
					if (t.candestroy) {
						ctx.drawImage(this.lifeimg, x, y + 43);
						let hp = this.savedata.mapdata.maphp[cx][cy];
						if (hp >= 10 && (!this.savedata.config.animation || hp == 20 || this.animcounter % 8 < 4)) {
							ctx.drawImage(this.numimg[Math.floor(hp / 10)], x + 10, y + 44);
						}
						if (!this.savedata.config.animation || this.animcounter % 8 < 4) {
							ctx.drawImage(this.numimg[hp % 10], x + 17, y + 44);
						}
					}
					if (cunit) {
						let cname = cunit.country;
						let u = Unit[Unit_imglist[cunit.udata.fname].uname];

						ctx.drawImage(this.lifeunitimg, ux, uy + 30);
						let hp = cunit.udata.hp;
						if (hp >= 10) {
							ctx.drawImage(this.numimg[Math.floor(hp / 10)], ux + 9, uy + 29);
						}
						ctx.drawImage(this.numimg[hp % 10], ux + 16, uy + 29);
						if (u.fuel > 0) {
							ctx.drawImage(this.fuelunitimg, ux, uy + 37);
							let fuel = cunit.udata.fuel;
							if (fuel >= 10) {
								ctx.drawImage(this.numimg[Math.floor(fuel / 10)], ux + 9, uy + 37);
							}
							ctx.drawImage(this.numimg[fuel % 10], ux + 16, uy + 37);
						}
						if (u.ammo > 0) {
							ctx.drawImage(this.bulletimg, ux, uy + 47);
							let ammo = cunit.udata.ammo;
							ctx.drawImage(this.numimg[ammo % 10], ux + 16, uy + 45);
						}

						this.drawunit(cunit.udata, ux + 4, uy + 14, this.savedata.countrydata[cname].unitdirection === "reverse");
						if (cunit.udata.capture) {
							ctx.drawImage(this.captureimg[cname], ux + 4, uy + 22);
						}
						if (cunit.udata.load) {
							ctx.drawImage(this.loadimg[cname], ux + 4, uy + 22);
						}
						if (cunit.udata.stealth) {
							ctx.drawImage(this.stealthimg[cname], ux + 4, uy + 22);
						}
						ctx.font = "700 12px ＭＳ 明朝, sans serif";
						let twidth = ctx.measureText(u.name).width;
						ctx.lineWidth = 0.1;
						let dx = 12 - twidth / 2;
						ctx.save();
						ctx.translate(ux + 12, 0);
						ctx.scale(u.name.length > 3 ? 0.75 - u.name.length / 20 : 0.7, 1);
						ctx.translate(-(ux + 12) , 0);
						for (let i = 0 ; i < u.name.length ; i++) {
							ctx.fillStyle = "black";
							ctx.font = "900 12px ＭＳ 明朝, sans serif";
							ctx.fillText(u.name.substr(i, 1), Math.floor(ux + dx), uy + 16);
							let tw = ctx.measureText(u.name.substr(i, 1)).width;
							ctx.font = "12px ＭＳ 明朝, sans serif";
							ctx.fillStyle = "white";
							ctx.fillText(u.name.substr(i, 1), Math.floor(ux + dx + 0.5), uy + 16);
							dx += tw;
						}
						ctx.restore();
					}
				}
			}

			if (this.isinside(cx, cy)) {
				let c = this.animcounter % 8;
				let rotate = 0;
				let ax = [ [ 14, 11 ], [ -14, -11 ], [ -14, -11 ], [  14,  11 ] ];
				let ay = [ [ 14, 11 ], [ 	14,  11 ], [ -14, -11 ], [ -14, -11 ] ];
				if (cy >=10 || cy >= this.savedata.mapdata.height - 2) {
					if (cx >= 14 || cx >= this.savedata.mapdata.width - 2) {
						rotate = 2;
					}
					else {
						rotate = 3;
					}
				}
				else {
					if (cx >= 14 || cx >= this.savedata.mapdata.width - 2) {
						rotate = 1;
					}
				}
				let img;
				if (this.select_mode === "Unit") {
					if (this.select_unit.substr(0, 6) === "delete") {
						img = this.hammerimg;
					}
					else {
						img = this.productimg;
					}
				}
				else {
					img = this.cursorarrowimg[rotate];
				}
				if (c < 6 || !this.savedata.config.animation) {
					if (rotate < 2) {
						ctx.drawImage(img, cx * Sqsize + ax[rotate][0], cy * Sqsize + ay[rotate][0]);
					}
					ctx.drawImage(this.cursorimg, cx * Sqsize - 3, cy * Sqsize - 3);
					if (rotate >= 2) {
						ctx.drawImage(img, cx * Sqsize + ax[rotate][0], cy * Sqsize + ay[rotate][0]);
					}
				}
				else if (c == 6) {
					if (rotate < 2) {
						ctx.drawImage(img, cx * Sqsize + ax[rotate][1], cy * Sqsize + ay[rotate][1]);
					}
					ctx.drawImage(this.cursorimg2, cx * Sqsize - 4, cy * Sqsize - 4);
					if (rotate >= 2) {
						ctx.drawImage(img, cx * Sqsize + ax[rotate][1], cy * Sqsize + ay[rotate][1]);
					}
				}
				else  {
					ctx.drawImage(img, cx * Sqsize + ax[rotate][1], cy * Sqsize + ay[rotate][1]);
					ctx.drawImage(this.cursorimg3, cx * Sqsize - 4, cy * Sqsize - 4);
				}
			}
			ctx.restore();
			if (this.isinside(cx, cy)) {
				ctx.fillStyle = "black";
				ctx.font = "16px Century, sans serif";
				ctx.textBaseline	= "bottom";
				ctx.fillText("(" + cx + "," + cy + ") ", 10, this.savedata.mapdata.height * Sqsize + 22);
			}
		}

		this.copymap = function(from, to) {
			for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
				to[x] = [];
				for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(this.mapbeforedrag, this.savedata.mapdata.map);
		}
		this.backupmap = function() {
			this.copymap(this.savedata.mapdata.map, this.mapbeforedrag);
		}

		this.drawtool = function() {
			let ctx = this.ctx;
			let tx = this.tx;
			let ty = this.ty;
			if (this.select_mode === "Map") {
				ctx.drawImage(this.changesizeimg, this.maprect.x + this.maprect.w - 0.5 * Sqsize, this.maprect.y + this.maprect.h - 0.5 * Sqsize);
			}
		}

		this.draw = function() {
			let ctx = this.ctx;
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, this.maprect.w + 8, this.maprect.h + 25);
			ctx.fill();
			this.drawmap();
			if (this.usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < this.savedata.mapdata.width && 0 <= y && y < this.savedata.mapdata.height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetriver = function(x, y) {
			let map = this.savedata.mapdata.map;
			let dx = [ 0, 0, -1, -1 ];
			let dy = [-1, 0, -1, 0 ];
			for (let i = 0 ; i < 4 ; i++) {
				let x2 = x + dx[i];
				let y2 = y + dy[i];
				let allriver = true;
				for (let dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (let dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						let x3 = x2 + dx2;
						let y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || map[x3][y3] != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			let map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				for (let dx = -1 ; dx <= 1 ; dx++) {
					for (let dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						let x2 = x + dx;
						let y2 = y + dy;
						if (this.isinside(x2, y2) && map[x2][y2] == "reef") {
							map[x2][y2] = "sea";
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tname) {
			let map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				let t = Terrain_imglist[map[x][y]];
				if (t.large == true) {
					for (let dx = 0 ; dx < t.size ; dx++) {
						for (let dy = 0 ; dy < t.size ; dy++) {
							let x2 = x - t.imgdata.x + dx;
							let y2 = y - t.imgdata.y + dy;
							if (t.land) {
								map[x2][y2] = "plain";
								this.deletenearreef(x2, y2);
							}
							else {
								map[x2][y2] = "sea";
							}
						}
					}
				}
				map[x][y] = tname;
				t = Terrain_imglist[tname];
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.buildingcount = {};
		this.buildingcountrycount = [];
		this.totalbuildingcount = 0;

		this.countbuilding = function() {
			this.totalbuildingcount = 0;
			for (let t in Terrain_imglist) {
				if (Terrain_imglist[t].building) {
					this.buildingcount[t] = 0;
				}
			}
			for (let c = 0 ; c < Country.length ; c++) {
				this.buildingcountrycount[c] = 0;
			}
			for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
				for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
					let m = this.savedata.mapdata.map[x][y];
					if (Terrain_imglist[m].building) {
						this.buildingcountrycount[Terrain_imglist[m].countrynum]++;
						this.buildingcount[m]++;
						this.totalbuildingcount++;
					}
				}
			}
		}

		this.setmap = function(x, y, tname, check) {
			let map = this.savedata.mapdata.map;
			check = check || false;
			retval = false;
			let t = Terrain_imglist[tname];
			if (this.isinside(x, y)) {
				if (tname == "pipe_c") {
					if (map[x][y] == "pipe" && 
						((this.isinside(x - 1, y) && map[x - 1][y] == "pipe" && this.isinside(x + 1, y) && map[x + 1][y] == "pipe") ||
						 (this.isinside(x, y - 1) && map[x][y - 1] == "pipe" && this.isinside(x, y + 1) && map[x][y + 1] == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tname);
							}
					}
				}
				else if (tname == "reef") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
							for (let dx = -1 ; dx <= 1 ; dx++) {
								for (let dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									let x2 = x + dx;
									let y2 = y + dy;
									if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, "sea");
									}
								}
							}
						}
					}
				}
				else if (tname == "shoal") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (tname == "river" || tname == "wideriver") {
					if (tname == "wideriver" || this.cansetriver(x, y)) {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					let delnum = 0;
					let x2;
					let y2;
					for (x2 = 0; x2 < this.savedata.mapdata.width ; x2++) {
						for (y2 = 0 ; y2 < this.savedata.mapdata.height ; y2++) {
							let t2 = Terrain_imglist[map[x2][y2]];
							if (t2.hq == true && t.country == t2.country && !(x == x2 && y == y2)) {
								delnum = 1;
								break;
							}
						}
						if (delnum == 1) {
							break;
						}
					}
					let t2 = Terrain_imglist[map[x][y]];
					if (!this.savedata.mapdata.buildinglimit || this.totalbuildingcount + ((t2.building) ? 0 : 1) - delnum <= 60) {
						retval = true;
						if (!check) {
							if (delnum == 1) {
								this.changemap(x2, y2, "plain");
							}
							this.changemap(x, y, tname);
						}
					}
				}
				else if (t.building && this.savedata.mapdata.buildinglimit) {
					let t2 = Terrain_imglist[map[x][y]];
					if (this.totalbuildingcount + ((t2.building) ? 0 : 1) <= 60) {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < this.savedata.mapdata.width && y + t.size - 1 < this.savedata.mapdata.height) {
						retval = true;
						if (!check) {
							for (let dy = 0 ; dy < t.size ; dy++) {
								for (let dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tname + dx + "" + dy);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tname);
					}
				}
			}
			return retval;
		}

		this.setcanvas = function() {
			this.canvas.width = this.maprect.w;
			this.canvas.height = this.maprect.h + 24;
			if (this.usetool) {
				this.UI_Base.x = this.canvas.width + 8;
				this.UI_Base.update();
				this.canvas.width += Toolwidth + 8;
				if (this.canvas.height < Toolheight) {
					this.canvas.height = Toolheight;
				}
			}

			this.tx = this.maprect.w;
			this.ty = 0;

			let ctx = this.ctx;
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, this.canvas.width, this.canvas.height);
			ctx.fill();
		}

		this.init = function(w, h, clear) {
			this.setsize(w, h, clear);
			this.setcanvas();
			this.countbuilding();
		}

		this.savedata.mapdata = {
			width:		Defaultwidth,
			height:		Defaultheight,
			maptype:	0,
			map:			[],
		};

		this.savedata.countrydata = {};
		for (let i = 0 ; i < Country.length ; i++) {
			let c = Country[i];
			if (c.npc) {
				continue;
			}
			this.savedata.countrydata[c.fname] = {
				front: {
					shogun:	null,
					bp:			0
				},
				back:	{
					shogun: null,
					bp:			0
				},
				money: 0,
				unitdirection:	"normal",
				unitcountrytype: c.fname,
				unitdata: [],
			}
		}

		this.debug_style = null;
	//	this.debug_style = { lineWidth: 1 };

		this.select_mode = "Terrain";
		this.select_terrain_mode = "Normal";
		this.select_terrain = "plain";
		this.select_unitcountry = "rs";
		this.select_unit = "infantry_rs";
		this.select_unitlock = "lock";
		this.select_edit_unit = null;

		this.checkconfigdata();
		this.checkmapdata();
//		this.debug_style = { lineWidth: 1 };

		this.Button_new = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: path + "image/button/new.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									})
		});
		this.Button_new.onmousedown = function(evt) {
			if (!(evt.buttons & 1)) {
				return;
			}
			this.arg.init(this.arg.savedata.mapdata.width, this.arg.savedata.mapdata.height, true);
			this.arg.draw();
		}
		this.Button_open = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: path + "image/button/open.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									})
		});
		this.Button_open.onmousedown = function(evt) {
			if (!(evt.buttons & 1)) {
				return;
			}
			let input = document.createElement("input");
			input.type = "file"
			input.me = this.arg;
			input.onchange = function(e) {
				let me = this.me;
				let map = me.savedata.mapdata.map;
				if (this.files.length > 0){
					let f = this.files[0];
					let reader = new FileReader();
					reader.me = me;
					reader.onload = (function(file) {
						let me = this.me;
						let loaddata = JSON.parse(file.target.result);
						if (loaddata && loaddata.fwmapdataver) {
							if (loaddata.fwmapdataver == 1) {
								me.savedata.fwmapdataver = 2;
								me.savedata.mapdata.width = loaddata.width;
								me.savedata.mapdata.height = loaddata.height;
								me.savedata.mapdata.maptype = 0;
								me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, true);
								let map = me.savedata.mapdata.map = loaddata.map;
								for (let i = 0 ; i < Country.length - 1 ; i++) {
									let c = Country[i];
									if (c.npc) {
										continue;
									}
									if (loaddata.unitdata !== undefined) {
										me.savedata.countrydata[c.fname].unitdata = loaddata.unitdata[c.fname];
									}
									else {
										me.savedata.countrydata[c.fname].unitdata = [];
									}
								}
							}
							else {
								me.savedata = loaddata;
								let cx = me.savedata.mapdata.cx;
								let cy = me.savedata.mapdata.cy;
								let selectunit = me.savedata.mapdata.selectunit;
								me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, false);
								me.savedata.mapdata.cx = (cx !== undefined) ? cx : 0;
								me.savedata.mapdata.cy = (cy !== undefined) ? cy : 0;
								me.savedata.mapdata.selectunit = (selectunit !== undefined) ? selectunit : 0;
							}
							me.checkconfigdata();
							me.checkmapdata();
							me.checkunitdata();
							me.setunitmap();
							me.select_edit_unit = null;
							if (me.savedata.mapdata.selectunit) {
								me.select_edit_unit = me.findunit(me.savedata.mapdata.cx, me.savedata.mapdata.cy);
							}
							me.select_mode = "UEdit";
							me.draw();
							me.select_terrain_mode = "Normal";
							me.UI_Base.paint();
						}
						else {
							alert("ファイルの形式が違います");
						}
					});
					reader.readAsText(f);	
				}
			}
			input.click();
		}

		this.Button_save = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: path + "image/button/save.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									}),
		});
		this.Button_save.onmousedown = function(evt) {
			if (!(evt.buttons & 1)) {
				return;
			}
			let blob = new Blob([JSON.stringify(this.arg.savedata, null, ' ')], {type: "application/json"});
			let a = document.createElement("a");
			a.href = URL.createObjectURL(blob);
			document.body.appendChild(a);
			a.target = "_blank";
			a.download = "save.json";
			a.click();
			document.body.removeChild(a);
		}

		this.Button_sshot = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: path + "image/button/sshot.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									}),
		});
		this.Button_sshot.onmousedown = function(evt) {
			if (!(evt.buttons & 1)) {
				return;
			}
			let ua = window.navigator.userAgent.toLowerCase();
			if (ua.indexOf('chrome') >= 0 && ua.indexOf('edge') < 0) {
				alert("Please use context menu (right click) to save image.");
				return;
			}
			let c = document.createElement("canvas");
			let width = c.width = this.arg.maprect.w;
			let height = c.height = this.arg.maprect.h;
			let img = this.ctx.getImageData(0, 0, width, height);
			c.getContext('2d').putImageData(img, 0, 0);

			let base64 = c.toDataURL('image/png');
			let tmp = base64.split(',');
			let data = atob(tmp[1]);
			let mime = tmp[0].split(':')[1].split(';')[0];
			let buf = new Uint8Array(data.length);
			for (let i = 0; i < data.length; i++) {
				buf[i] = data.charCodeAt(i);
			}
			let blob = new Blob([buf], { type: mime });
			let a = document.createElement("a");
			a.href = URL.createObjectURL(blob);
			document.body.appendChild(a);
			a.target = "_blank";
			a.download = "sshot.png";
			a.click();
			document.body.removeChild(a);
		}


		this.Selector_Mode_style =					{ fillStyle: "white", lineWidth: 1, align: "center" };
		this.Selector_Mode_moverstyle =		{ fillStyle: "white", lineWidth: 2, align: "center" };
		this.Selector_Mode_offstyle =			{ fillStyle: "lightgray", lineWidth: 1, align: "center" };
		this.Selector_Mode_moveroffstyle =	{ fillStyle: "lightgray", lineWidth: 2, align: "center" };
		this.Selector_Mode = UI_Selector({
			position:		"newline",
			y:					30,
			width:			200,
			height:			25,
			selectnum:	0,
			bindvar:		"this.arg.select_mode",
			onchange:		function() {
										if (this.selectvalue === "Terrain" || this.selectvalue === "Unit") {
											this.arg.select_edit_unit = null;
										}
//										if (this.arg.select_edit_unit != this.arg.findunit(this.arg.savedata.mapdata.cx, this.arg.savedata.mapdata.cy)) {
//										}
									},
			data:	[
				UI_Drawdata_Text({
					text:						"Terrain",
					value:					"Terrain",
					width:					48,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Unit",
					value:					"Unit",
					width:					36,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Map",
					value:					"Map",
					width:					36,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"UEdit",
					value:					"UEdit",
					width:					42,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"CEdit",
					value:					"CEdit",
					width:					42,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Config",
					value:					"Config",
					width:					46,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
			],
		});


		this.Selector_Terrain_Mode = UI_Selector({
			position:				"newline",
			y:							0,
			width:					200,
			height:					25,
			selectnum:	0,
			bindvar:	"this.arg.select_terrain_mode",
			data:	[
				UI_Drawdata_Text({
					text:						"Normal",
					value:					"Normal",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Land",
					value:					"Land",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Sea",
					value:					"Sea",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Shoal",
					value:					"Shoal",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"River",
					value:					"River",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
			],
		});

		this.create_drawdata_image = function(data, i, a) {
			if (data.type === "imgsp") {
				let t = Terrain_imglist[data.name];
				let timg = t.imgdata;
				imgdat =	UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		(t.large) ? 16 : timg.height,
						position:				this.position,
						x:							this.x,
						y:							this.y,
						value:					data.name,
						param:					this.me.terrainimg[timg.num],
						imagesrcx:			timg.ix * 16,
						imagesrcy:			timg.iy * 16,
						imagesrcw:			(t.large) ? timg.height : 16,
						imagesrch:			timg.height,
						style:					Selector_Terrain_style,
						moverstyle:			Selector_Terrain_moverstyle,
						offstyle:				Selector_Terrain_offstyle,
						moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				if (data.name.substr(0, 3) === "hq_") {
					this.stdatahq[data.name.substr(3, 2)] = imgdat;
				}
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "imgsp2") {
				let t = Unit_imglist[data.name].imgdata;
				imgdat =	UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					imageheight:		t.height,
					position:				this.position,
					x:							this.x,
					y:							this.y,
					value:					data.name,
					image:					this.me.unitimg[t.num],
					imagesrcx:			t.ix * 16,
					imagesrcy:			t.iy * 16,
					imagesrcw:			16,
					imagesrch:			t.height,
					style:					Selector_Terrain_style,
					moverstyle:			Selector_Terrain_moverstyle,
					offstyle:				Selector_Terrain_offstyle,
					moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				if (data.name.substr(0, 8) === "infantry") {
					this.stdatainf[data.name.substr(9, 2)] = imgdat;
				}
				if (data.name.substr(0, 4) === "mech") {
					this.stdatamech[data.name.substr(5, 2)] = imgdat;
				}
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "img") {
				imgdat =	UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					imageheight:		16,
					position:				this.position,
					x:							this.x,
					y:							this.y,
					value:					data.name,
					src:						path + data.src,
					style:					Selector_Terrain_style,
					moverstyle:			Selector_Terrain_moverstyle,
					offstyle:				Selector_Terrain_offstyle,
					moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "newline") {
				this.position = "newline";
				this.x = 0;
				this.y = 0;
				if (data.x) {
					this.x = data.x;
				}
				if (data.y) {
					this.y = data.y;
				}
			}
			else if (data.type === "space") {
				if (this.position !== "newline") {
					this.position = "relative";
				}
				if (data.x) {
					this.x += data.x;
				}
				if (data.y) {
					this.y += data.y;
				}
			}
		}
		let Selector_Terrain_style =					{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4, fillStyle: "gray" };
		let Selector_Terrain_moverstyle =			{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3, fillStyle: "gray" };
		let Selector_Terrain_offstyle =				{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4 };
		let Selector_Terrain_moveroffstyle =	{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3 };
		this.Selector_Terrain_data = [];
		this.Selector_Terrain_datahq = {};
		{
			let imgdat;
			let stdata = this.Selector_Terrain_data;
			let stdatahq = this.Selector_Terrain_datahq;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				stdatahq:	stdatahq,
				me:				this,
			};
			TerrainUI_data.forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Terrain = UI_Selector({
			position:			"absolute",
			x:						0,
			y:						0,
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		let Selector_Terrain_Country_style =					{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4 };
		let Selector_Terrain_Country_moverstyle =			{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3 };

		this.Button_Terrain_Country = [];
		this.Button_Terrain_Countryimage = [];
		this.Button_Terrain_BuildingCounter = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Button_Terrain_Countryimage[i - 1] = [];
			for (let j = 1 ; j < Country.length ; j++) {
				this.Button_Terrain_Countryimage[i - 1][j - 1] = UI_Drawdata_Image({
					width:			24,
					height:			24,
					value:			Country[j].fname,
					src: 				path + "image/button/" + Country[j].fname + ".png",
					style:			Selector_Terrain_Country_style,
					moverstyle:	Selector_Terrain_Country_moverstyle,
				})
			}
		}
		for (let i = 0 ; i < Country.length ; i++) {
			if (i > 0) {
				this.Button_Terrain_Country[i - 1] = UI_ClickSelector({
					width:			24,
					height:			24,
					position:		"newline",
					x:					6,
					y:					30,
					selectnum:	i - 1,
					value:			Country[i].fname,
					bindvar:		"this.arg.savedata.countrydata[this.value].unitcountrytype",
					data:				[ this.Button_Terrain_Countryimage[i - 1][0],
												this.Button_Terrain_Countryimage[i - 1][1],
												this.Button_Terrain_Countryimage[i - 1][2],
												this.Button_Terrain_Countryimage[i - 1][3],
												this.Button_Terrain_Countryimage[i - 1][4],
											],
					preprocess:		function() {
												this.arg.Selector_Terrain_datahq[this.value].imagesrcy = this.selectnum * 32;
												this.arg.Selector_Unit_datainf[this.value].imagesrcx = this.selectnum * 16;
												this.arg.Selector_Unit_datamech[this.value].imagesrcx = this.selectnum * 16 + 80;
												this.arg.ClickSelector_Unit_datainf[this.value][0].imagesrcx = this.selectnum * 16;
												this.arg.ClickSelector_Unit_datainf[this.value][1].imagesrcx = this.selectnum * 16;
											}
				});
			}
			this.Button_Terrain_BuildingCounter[i] = UI_Button({
				position:		"absolute",
				x:					0,
				y:					30 * i + 20,
				preprocess:	function() {
											this.display = this.arg.savedata.config.displayterrainnum;
											this.data[0].text = this.arg.buildingcountrycount[i];
										},
				data: 			[
											UI_Drawdata_PlusIntegerImage({
												src:				path + "image/icon/num.png",
												width:			24,
												height:			7,
												style:			{ align: "right" },
											}),
										],
			});
		}
		this.Button_Terrain_BuildingCounter[6] = UI_Button({
			position:		"absolute",
			x:					0,
			y:					0,
			preprocess:	function() {
										this.display = this.arg.savedata.config.displayterrainnum;
										this.data[0].text = this.arg.totalbuildingcount;
									},
			data: 			[
										UI_Drawdata_PlusIntegerImage({
											src:				path + "image/icon/num.png",
											width:			24,
											height:			7,
											style:			{ align: "right" },
										}),
									],
		});
		this.Button_Terrain_BuildingCounter[7] = UI_Button({
			position:		"absolute",
			x:					0,
			y:					-10,
			preprocess:	function() {
										this.display = this.arg.savedata.mapdata.buildinglimit && this.arg.savedata.config.displayterrainnum;
										this.data[0].text = 60 - this.arg.totalbuildingcount;
									},
			data: 			[
										UI_Drawdata_PlusIntegerImage({
											src:				path + "image/icon/num.png",
											width:			24,
											height:			7,
											style:			{ align: "right" },
										}),
									],
		});

		this.Container_Terrain_Country = UI_Container({
			x:				0,
			y:				70,
			position:	"absolute",
			style:		this.debug_style,
			data:			[
									this.Button_Terrain_Country[0],
									this.Button_Terrain_Country[1],
									this.Button_Terrain_Country[2],
									this.Button_Terrain_Country[3],
									this.Button_Terrain_Country[4],
									this.Button_Terrain_BuildingCounter[0],
									this.Button_Terrain_BuildingCounter[1],
									this.Button_Terrain_BuildingCounter[2],
									this.Button_Terrain_BuildingCounter[3],
									this.Button_Terrain_BuildingCounter[4],
									this.Button_Terrain_BuildingCounter[5],
									this.Button_Terrain_BuildingCounter[6],
									this.Button_Terrain_BuildingCounter[7],
								],
		});

		this.Terrain_Building_Counter_data = [];
		for (let i = 0 ; i < Country.length ; i++) {
			let j = 0;
			for (let bname in Buildinglist) {
				if (bname === "assign") {
					continue;
				}
				if (!(i == 0 && (j == 0 || j == 6))) {
					this.Terrain_Building_Counter_data.push(UI_Button({
						position:		"absolute",
						x:					j * 30 + 31,
						y:					i * 30 + 20,
						param:			i,
						preprocess:	function() {
												this.display = this.arg.savedata.config.displayterrainnum;
												this.data[0].text = this.arg.buildingcount[bname + "_" + Country[this.param].fname];
												},
						data: 			[
													UI_Drawdata_PlusIntegerImage({
														src:				path + "image/icon/num.png",
														width:			24,
														height:			7,
														style:			{ align: "right" },
													}),
												],
					}));
				}
				j++;
			}
		}

		this.Container_Terrain_Building_Counter = UI_Container({
			x:				0,
			y:				70,
			position:	"absolute",
			style:		this.debug_style,
			data:			this.Terrain_Building_Counter_data,
		});

		this.Container_Terrain_Normal = UI_Container({
			value:			"Normal",
			style:			this.debug_style,
			position:		"absolute",
			y:					35,
			data:				[
										this.Container_Terrain_Country,
										this.Selector_Terrain,
										this.Container_Terrain_Building_Counter,
									],
		});

		this.Selector_Terrain_Land_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Land_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				me:				this,
			};
			Terrain_Land_UI_data.forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Terrain_Land = UI_Selector({
			width:				0,
			height:				0,
			space:				3,
			lineheight:		27,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Land_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Land = UI_Container({
			value:			"Land",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Land,
									],
		});

		this.Selector_Terrain_Sea_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Sea_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				me:				this,
			};
			Terrain_Sea_UI_data.forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Terrain_Sea = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Sea_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Sea = UI_Container({
			value:			"Sea",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Sea,
									],
		});

		this.Selector_Terrain_Shoal_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Shoal_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				me:				this,
			};
			Terrain_Shoal_UI_data.forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Terrain_Shoal = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Shoal_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Shoal = UI_Container({
			value:			"Shoal",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Shoal,
									],
		});

		this.Selector_Terrain_River_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_River_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				me:				this,
			};
			Terrain_River_UI_data.forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Terrain_River = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_River_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_River = UI_Container({
			value:			"River",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_River,
									],
		});

		this.Container_Terrain_Container = UI_Container({
			position:		"newline",
			x: 					0,
			y:					0,
			bindvar:		"this.arg.select_terrain_mode",
			style:			this.debug_style,
			data:				[
										this.Container_Terrain_Normal,
										this.Container_Terrain_Land,
										this.Container_Terrain_Sea,
										this.Container_Terrain_Shoal,
										this.Container_Terrain_River,
									],
		});

		this.Container_Terrain = UI_Container({
			value:			"Terrain",
			style:			this.debug_style,
			position:		"absolute",
//			bindvar:		"this.select_terrain_mode",
			data:				[
										this.Selector_Terrain_Mode,
										this.Container_Terrain_Container,
									],
		});

		this.Selector_Unit_Country_image = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Selector_Unit_Country_image[i - 1] = UI_Drawdata_Image({
				width:			24,
				height:			24,
				value:			Country[i].fname,
				src: 				path + "image/button/" + Country[i].fname + ".png",
				style:					Selector_Terrain_style,
				moverstyle:			Selector_Terrain_moverstyle,
				offstyle:				Selector_Terrain_offstyle,
				moveroffstyle	:	Selector_Terrain_moveroffstyle,
			});
		}

		this.Selector_Unit_Country = UI_Selector({
			space:			6,
			px:					6,
			width:			24,
			height:			24,
			style:			this.debug_style,
			selectnum:	0,
			value:			"unit_country",
			bindvar:		"this.arg.select_unitcountry",
			data:				this.Selector_Unit_Country_image,
		});

		this.ClickSelector_Unitlock = UI_ClickSelector({
			position:		"absolute",
			x:					180,
			y:					0,
			style:			this.debug_style,
			selectnum:	0,
			bindvar:		"this.arg.select_unitlock",
			data:				[ 
				UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					value:					"lock",
					imageheight:		16,
					src:						path + "image/button/lock.png",
					style:					Selector_Terrain_Country_style,
					moverstyle:			Selector_Terrain_Country_moverstyle,
				}),
				UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					value:					"unlock",
					imageheight:		16,
					src:						path + "image/button/unlock.png",
					style:					Selector_Terrain_Country_style,
					moverstyle:			Selector_Terrain_Country_moverstyle,
				}),
			],
		});

		this.Button_Unit_Counter = [];
		this.Button_Unit_CounterLeft = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Button_Unit_Counter[i - 1] = UI_Button({
				position:		"absolute",
				x:					i * 30 - 30,
				y:					8,
				param:			i,
				preprocess:	function() {
											this.data[0].text = this.arg.unitcountrycount[Country[this.param].fname];
										},
				data: 			[
											UI_Drawdata_PlusIntegerImage({
												src:				path + "image/icon/num.png",
												width:			24,
												height:			7,
												style:			{ align: "right" },
											}),
										],
			});
			this.Button_Unit_CounterLeft[i - 1] = UI_Button({
				position:		"absolute",
				x:					i * 30 - 30,
				y:					0,
				param:			i,
				preprocess:	function() {
											this.display = this.arg.savedata.mapdata.unitlimit;
											this.data[0].text = 50 - this.arg.unitcountrycount[Country[this.param].fname];
										},
				data: 			[
											UI_Drawdata_PlusIntegerImage({
												src:				path + "image/icon/num.png",
												width:			24,
												height:			7,
												style:			{ align: "right" },
											}),
										],
			});
		}

		this.Container_Unit_Counter = UI_Container({
			px:				6,
			space:		6,
			position:	"newline",
			y:				30,
			style:		this.debug_style,
			data:			[
									this.Button_Unit_Counter[0],
									this.Button_Unit_Counter[1],
									this.Button_Unit_Counter[2],
									this.Button_Unit_Counter[3],
									this.Button_Unit_Counter[4],
									this.Button_Unit_CounterLeft[0],
									this.Button_Unit_CounterLeft[1],
									this.Button_Unit_CounterLeft[2],
									this.Button_Unit_CounterLeft[3],
									this.Button_Unit_CounterLeft[4],
								],
		});

		this.ClickSelector_Unit_Direction = [];
		this.ClickSelector_Unit_datainf = {};

		for (let i = 1 ; i < Country.length ; i++) {
			let t = Unit_imglist["infantry_" + Country[i].fname].imgdata;
			this.ClickSelector_Unit_Direction[i - 1] = UI_ClickSelector({
				width:			30,
				height:			30,
				selectnum:	0,
				bindvar:		"this.arg.savedata.countrydata['" + Country[i].fname + "'].unitdirection",
				preprocess:	function() {
											this.data[0].imagesrcx = Countrynamenum[this.arg.savedata.countrydata[Country[i].fname].unitcountrytype] * 16;
											this.data[1].imagesrcx = Countrynamenum[this.arg.savedata.countrydata[Country[i].fname].unitcountrytype] * 16;
				},
				data:				[
					UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		16,
						value:					"normal",
						image:					this.unitimg[t.num],
						imagesrcx:			t.ix * 16,
						imagesrcy:			t.iy * 16,
						imagesrcw:			16,
						imagesrch:			16,
						style:					Selector_Terrain_Country_style,
						moverstyle:			Selector_Terrain_Country_moverstyle,
					}),
					UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		16,
						value:					"reverse",
						image:					this.unitimg[t.num],
						imagesrcx:			t.ix * 16,
						imagesrcy:			t.iy * 16,
						imagesrcw:			16,
						imagesrch:			16,
						transform:			"reversex",
						style:					Selector_Terrain_Country_style,
						moverstyle:			Selector_Terrain_Country_moverstyle,
					}),
				],
			});
			this.ClickSelector_Unit_datainf[Country[i].fname] = [ 
				this.ClickSelector_Unit_Direction[i - 1].data[0],
				this.ClickSelector_Unit_Direction[i - 1].data[1],
			];
		}

		this.Container_Unit_Direction = UI_Container({
			px:				6,
			space:		6,
			position:	"newline",
			y:				20,
			style:		this.debug_style,
			data:			[
									this.ClickSelector_Unit_Direction[0],
									this.ClickSelector_Unit_Direction[1],
									this.ClickSelector_Unit_Direction[2],
									this.ClickSelector_Unit_Direction[3],
									this.ClickSelector_Unit_Direction[4],
								],
		});

		this.Selector_Unit_image = [];
		this.Selector_Unit_datainf = {};
		this.Selector_Unit_datamech = {};

		for (let i = 1 ; i < Country.length ; i++) {
			let stdata = this.Selector_Unit_image[i - 1] = [];
			let stdatainf = this.Selector_Unit_datainf;
			let stdatamech = this.Selector_Unit_datamech;
			let arg = {
				position:	"static",
				x:					0,
				y:					0,
				stdata:			stdata,
				stdatainf:	stdatainf,
				stdatamech:	stdatamech,
				me:				this,
			};
			let imgdat;
			UnitUI_data[Country[i].fname].forEach(this.create_drawdata_image, arg);
		}

		this.Selector_Unit = [];
		this.Container_CountryUnit = [];
		this.Container_CountryUnitCount = [];
		this.Unit_Counter_data = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Selector_Unit[i - 1] = UI_Selector({
				space:				6,
				lineheight:		30,
				px:						6,
				bindvar:			"this.arg.select_unit",
				enablewheel:	true,
				data:					this.Selector_Unit_image[i - 1],
				style:				this.debug_style,
			});
			this.Unit_Counter_data[i - 1] = [];
			this.Selector_Unit[i - 1].data.forEach(function(data, j, a) {
				if (data.value.substr(0, 6) !== "delete") {
					this.Unit_Counter_data[i - 1].push(UI_Button({
						position:		"absolute",
						x:					data.rect.x - 5,
						y:					data.rect.y + 21,
						param:			data.value,
						preprocess:	function() {
								//			this.display = this.arg.savedata.config.displayterrainnum;
													this.data[0].text = this.arg.unitcount[this.param];
												},
						data: 			[
													UI_Drawdata_PlusIntegerImage({
														src:				path + "image/icon/num.png",
														width:			24,
														height:			7,
														style:			{ align: "right" },
													}),
												],
					}));
				}
			}, this);

			this.Container_CountryUnitCount[i - 1] = UI_Container({
				position:			"absolute",
				data:					this.Unit_Counter_data[i - 1],
			});
			this.Container_CountryUnit[i - 1] = UI_Container({
				value:				Country[i].fname,
				position:			"absolute",
				y:						0,
				data:					[
												this.Selector_Unit[i - 1],
												this.Container_CountryUnitCount[i - 1],
											],
				preprocess:		function() {
												this.data[0].data.forEach(function(data, i, a) {
													data.transform = (this.arg.savedata.countrydata[this.value].unitdirection === "reverse" && data.value !== "delete") ? "reversex" : null;
												}, this);
											},
			});
		}

if (0) {

		this.Terrain_Building_Counter_data = [];
		for (let i = 0 ; i < Country.length ; i++) {
			let j = 0;
			for (let bname in Buildinglist) {
				if (bname === "assign") {
					continue;
				}
				if (!(i == 0 && (j == 0 || j == 6))) {
					this.Terrain_Building_Counter_data.push(UI_Button({
						position:		"absolute",
						x:					j * 30 + 31,
						y:					i * 30 + 20,
						param:			i,
						preprocess:	function() {
												this.display = this.arg.savedata.config.displayterrainnum;
												this.data[0].text = this.arg.buildingcount[bname + "_" + Country[this.param].fname];
												},
						data: 			[
													UI_Drawdata_PlusIntegerImage({
														src:				path + "image/icon/num.png",
														width:			24,
														height:			7,
														style:			{ align: "right" },
													}),
												],
					}));
				}
				j++;
			}
		}
}

		this.Container_Unitlist = UI_Container({
			value:			"Unit",
			position:		"newline",
			y:					40,
			bindvar:		"this.arg.select_unitcountry",
			data:				[
										this.Container_CountryUnit[0],
										this.Container_CountryUnit[1],
										this.Container_CountryUnit[2],
										this.Container_CountryUnit[3],
										this.Container_CountryUnit[4],
									],
		});

		this.Container_Unit = UI_Container({
			value:			"Unit",
			position:		"absolute",
			style:			this.debug_style,
			data:				[
										this.Selector_Unit_Country,
										this.ClickSelector_Unitlock,
										this.Container_Unit_Counter,
										this.Container_Unit_Direction,
										this.Container_Unitlist
									],
		});

		this.Container_Mapsize = UI_Container({
			px:					0,
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		100,
												height:		20,
												text:			"Mapsize",
											}),
										}),
										UI_NumberBox({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											msg:				"width (1-100)",
											min:					1,
											max:					100,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:		"this.arg.savedata.mapdata.width",
											data:				UI_Drawdata_Text({
												width:			30,
												height:			20,
												style:			{ fillStyle: "white", align: "right", px: 3 },
											}),
											onchange:	function() {
												let num = Math.floor(+this.newvalue);
												if (num <= 0 || num > Maxwidth) {
													alert("width must be within 1-100.");
													return false;
												}
												if (this.num !== undefined && this.num != this.arg.savedata.mapdata.width) {
													this.arg.init(num, this.arg.savedata.mapdata.height, false);
													this.arg.draw();
												}
												return true;
											},
										}),
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		30,
												height:		20,
												text:			"×",
												style:		{ align: "center" },
											}),
										}),
										UI_NumberBox({
											px: 2,
											py: 2,
											msg:					"height (1-100)",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											min:					1,
											max:					100,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.savedata.mapdata.height",
											data:					UI_Drawdata_Text({
												width:			30,
												height:			20,
												style:			{ fillStyle: "white", align: "right", px: 3 },
											}),
											onchange:	function(text) {
												let num = Math.floor(this.newvalue);
												if (num <= 0 || num > Maxwidth) {
													alert("height must be within 1-100.");
													return false;
												}
												if (this.num !== undefined && this.num != this.arg.savedata.mapdata.height) {
													this.arg.init(this.arg.savedata.mapdata.width, num, false);
													this.arg.draw();
												}
												return true;
											},
										}),
									],
		});

		this.Container_Tileset = UI_Container({
			px:					0,
			position:		"newline",
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		100,
												height:		20,
												text:			"Tileset",
											}),
										}),
										UI_ClickSelector({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											bindvar:		"this.arg.savedata.mapdata.maptype",
											enablewheel:	"mouseover",
											data:				[	
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Normal",
													value:			0,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Wasteland",
													value:			1,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Desert",
													value:			2,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Snow",
													value:			3,
													style:			{ px: 5 },
												}),
											],
											onchange: function() {
												this.arg.draw();
											},
										}),
									],
		});

		this.Container_BuildingLimit = UI_Container({
			px:					0,
			position:		"newline",
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		100,
												height:		20,
												text:			"Building Limit",
											}),
										}),
										UI_ClickSelector({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											bindvar:		"this.arg.savedata.mapdata.buildinglimit",
											enablewheel:	"mouseover",
											data:				[	
												UI_Drawdata_Text({
													width:			40,
													height:			20,
													text:				"60",
													value:			true,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			40,
													height:			20,
													text:				"none",
													value:			false,
													style:			{ px: 5 },
												}),
											],
											onchange: function() {
												this.arg.draw();
											},
										}),
									],
		});

		this.Container_UnitLimit = UI_Container({
			px:					0,
			position:		"newline",
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		100,
												height:		20,
												text:			"Unit Limit",
											}),
										}),
										UI_ClickSelector({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											bindvar:		"this.arg.savedata.mapdata.unitlimit",
											enablewheel:	"mouseover",
											data:				[	
												UI_Drawdata_Text({
													width:			40,
													height:			20,
													text:				"50",
													value:			true,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			40,
													height:			20,
													text:				"none",
													value:			false,
													style:			{ px: 5 },
												}),
											],
											onchange: function() {
												this.arg.draw();
											},
										}),
									],
		});

		this.Container_Map = UI_Container({
			value:			"Map",
			position:		"absolute",
			lineheight:	30,
			data:				[
										this.Container_Mapsize,
										this.Container_Tileset,
										this.Container_BuildingLimit,
										this.Container_UnitLimit,
									],
		});

		this.Container_UEdit_text = UI_Container({
			position:		"absolute",
			py:					10,
			lineheight:	30,
			data:				[	
										UI_Button({
											style:	this.debug_style,
											data: 	[
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Unit",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"HP",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Ammo",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Fuel",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Capture",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Load",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Stealth",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Defence",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: [
												UI_Drawdata_Text({
													width:			240,
													height:			1,
													text:				"",
													style:			{ fillStyle: "#777777" },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											y:				-20,
											data: [
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Terrain",
													value:			0,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Container({
											preprocess: function() {
																		let mapdata = this.arg.savedata.mapdata;
																		let tname = mapdata.map[mapdata.cx][mapdata.cy];
																		let t = Terrain[Terrain_imglist[tname].name];
																		this.display = t.candestroy;
																	},
											data:	[
												UI_Button({
													style:			this.debug_style,
													preprocess: function() {
																				let mapdata = this.arg.savedata.mapdata;
																				let tname = mapdata.map[mapdata.cx][mapdata.cy];
																				let t = Terrain[Terrain_imglist[tname].name];
																				let timg = t.imgdata;
																				this.data[0].image = this.terrainimg[timg.num][mapdata.maptype];
																				if (!timg.large) {
																					this.data[0].imagesrcx = timg.ix * 16;
																					this.data[0].imagesrcy = timg.iy * 16 + timg.height - 16;
																					this.data[0].imagesrcw = 16;
																					this.data[0].imagesrch = 16;
																				}
																				else {
																					this.data[0].imagesrcx = (timg.ix + 0.875) * 16;
																					this.data[0].imagesrcy = (timg.iy + 1.875) * 16;
																					this.data[0].imagesrcw = 20;
																					this.data[0].imagesrch = 20;
																				}
																			},
													data: 			[
																				UI_Drawdata_Image({
																					id:							"edit_unit_image",
																					width:					16,
																					height:					16,
																					imagewidth:			16,
																					imageheight:		16,
																					imagesrcw:			16,
																					imagesrch:			16,
																				}),
																			],
												}),
												UI_NumberBox({
													position:			"relative",
													x:						10,
													y:						-2,
													style:				{ fillStyle: "white", lineWidth: 1 },
													moverstyle:		{ fillStyle: "white", lineWidth: 2 },
													px: 					2,
													py: 					2,
													msg:					"HP (1-99)",
													min:					1,
													max:					99,
													numtype:			"integer",
													enablewheel:	"mouseover",
													wheelnum:			1,
													bindvar:			"this.arg.savedata.mapdata.maphp[this.arg.savedata.mapdata.cx][this.arg.savedata.mapdata.cy]",
													data:					[
																					UI_Drawdata_Text({
																						width:			30,
																						height:			16,
																						style:			{ fillStyle: "white", align: "right", px: 3 },
																					}),
																				],
												}),
												UI_Button({
													position:				"relative",
													x:							5,
													data: 	[
														UI_Drawdata_Text({
															text:				"max",
															width:			35,
															height:			20,
															style:			this.Selector_Mode_style,
															moverstyle:	this.Selector_Mode_moverstyle,
														}),
													],
													onmousedown:		function(evt) {
																						if (!(evt.buttons & 1)) {
																							return;
																						}
																						this.arg.savedata.mapdata.maphp[this.arg.savedata.mapdata.cx][this.arg.savedata.mapdata.cy] = 99;
																					},
												}),
												UI_Button({
													data: 	[
														UI_Drawdata_Text({
															text:				"1/2",
															width:			35,
															height:			20,
															style:			this.Selector_Mode_style,
															moverstyle:	this.Selector_Mode_moverstyle,
														}),
													],
													onmousedown:		function(evt) {
																						if (!(evt.buttons & 1)) {
																							return;
																						}
																						this.arg.savedata.mapdata.maphp[this.arg.savedata.mapdata.cx][this.arg.savedata.mapdata.cy] = 49;
																					},
												}),
												UI_Button({
													data: 	[
														UI_Drawdata_Text({
															text:				"min",
															width:			35,
															height:			20,
															style:			this.Selector_Mode_style,
															moverstyle:	this.Selector_Mode_moverstyle,
														}),
													],
													onmousedown:		function(evt) {
																						if (!(evt.buttons & 1)) {
																							return;
																						}
																						this.arg.savedata.mapdata.maphp[this.arg.savedata.mapdata.cx][this.arg.savedata.mapdata.cy] = 1;
																					},
												}),
											],
										}),
									],
		});

		this.Container_UEdit_data = UI_Container({
			position:		"absolute",
			px:					80,
			py:					10,
			lineheight:	30,
			style:			this.debug_style,
			data:				[	
										// unit
										UI_Button({
											style:			this.debug_style,
											preprocess: function() {
																		let t = Unit_imglist[this.arg.select_edit_unit.udata.fname].imgdata;
																		this.data[0].image = this.unitimg[t.num];
																		this.data[0].imagesrcx = t.ix * 16;
																		this.data[0].imagesrcy = t.iy * 16;
																	},
											data: 			[
																		UI_Drawdata_Image({
																			id:							"edit_unit_image",
																			width:					16,
																			height:					16,
																			imagewidth:			16,
																			imageheight:		16,
																			image:					this.unitimg[0],
																			imagesrcx:			0 * 16,
																			imagesrcy:			0 * 16,
																			imagesrcw:			16,
																			imagesrch:			16,
												}),
											],
										}),
										UI_Button({
											position:			"relative",
											x:						35,
											style:				this.debug_style,
											preprocess:		function() {
																			this.data[0].text = "(" + this.arg.select_edit_unit.udata.x + "," + this.arg.select_edit_unit.udata.y + ")";
																		},
											data: 				[
																			UI_Drawdata_Text({
																				width:		50,
																				height:		20,
																				style: 		{ fontsize: 14 },
																			}),
																		],
										}),
										// hp
										UI_NumberBox({
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											msg:					"hp (1-10)",
											min:					1,
											max:					10,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.select_edit_unit.udata.hp",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			30,
													height:			20,
													style:	{ align: "right", px: 5 },
												}),
											],
										}),
										// ammo
										UI_NumberBox({
											preprocess:		function() {
																			let ammo = Unit[this.arg.select_edit_unit.udata.uname].ammo
																			this.display = ammo > 0;
																			this.max = ammo;
																			this.msg = "ammo (0-" + ammo + ")";
																		},
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											msg:					"",
											min:					0,
											max:					10,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.select_edit_unit.udata.ammo",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			30,
													height:			20,
													style:	{ align: "right", px: 5 },
												}),
											],
										}),
										UI_Button({
											preprocess:		function() {
																			let ammo = Unit[this.arg.select_edit_unit.udata.uname].ammo;
																			this.display = ammo > 0;
																			this.data[0].text = "/ " + ammo;
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].ammo > 0;
																		},
											data: 	[
												UI_Drawdata_Text({
													text:				"max",
													width:			40,
													height:			20,
													style:			this.Selector_Mode_style,
													moverstyle:	this.Selector_Mode_moverstyle,
												}),
											],
											onmousedown:		function(evt) {
																				if (!(evt.buttons & 1)) {
																					return;
																				}
																				let udata = this.arg.select_edit_unit.udata;
																				let u = Unit[udata.uname];
																				udata.ammo = u.ammo;
																			},
										}),
										UI_Button({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].ammo > 0;
																		},
											data: 	[
												UI_Drawdata_Text({
													text:				"1/2",
													width:			40,
													height:			20,
													style:			this.Selector_Mode_style,
													moverstyle:	this.Selector_Mode_moverstyle,
												}),
											],
											onmousedown:		function(evt) {
																				if (!(evt.buttons & 1)) {
																					return;
																				}
																				let udata = this.arg.select_edit_unit.udata;
																				let u = Unit[udata.uname];
																				udata.ammo = Math.floor(u.ammo / 2);
																			},
										}),
										// fuel
										UI_NumberBox({
											preprocess:		function() {
																			let fuel = Unit[this.arg.select_edit_unit.udata.uname].fuel
																			this.display = fuel > 0;
																			this.max = fuel;
																			this.msg = "fuel (0-" + fuel + ")";
																		},
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											msg:					"",
											min:					0,
											max:					10,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.select_edit_unit.udata.fuel",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			30,
													height:			20,
													style:	{ align: "right", px: 5 },
												}),
											],
										}),
										UI_Button({
											preprocess:		function() {
																			let fuel = Unit[this.arg.select_edit_unit.udata.uname].fuel;
																			this.display = fuel > 0;
																			this.data[0].text = "/ " + fuel;
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													style:			{ px: 5 },
												}),
											],
										}),
										UI_Button({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].fuel > 0;
																		},
											data: 	[
												UI_Drawdata_Text({
													text:				"max",
													width:			40,
													height:			20,
													style:			this.Selector_Mode_style,
													moverstyle:	this.Selector_Mode_moverstyle,
												}),
											],
											onmousedown:		function(evt) {
																				if (!(evt.buttons & 1)) {
																					return;
																				}
																				let udata = this.arg.select_edit_unit.udata;
																				let u = Unit[udata.uname];
																				udata.fuel = u.fuel;
																			},
										}),
										UI_Button({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].fuel > 0;
																		},
											data: 	[
												UI_Drawdata_Text({
													text:				"1/2",
													width:			40,
													height:			20,
													style:			this.Selector_Mode_style,
													moverstyle:	this.Selector_Mode_moverstyle,
												}),
											],
											onmousedown:		function(evt) {
																				if (!(evt.buttons & 1)) {
																					return;
																				}
																				let udata = this.arg.select_edit_unit.udata;
																				let u = Unit[udata.uname];
																				udata.fuel = Math.floor(u.fuel / 2);
																			},
										}),
										// capture
										UI_ClickSelector({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].cancapture ? true : false;
																		},
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.select_edit_unit.udata.capture",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"false",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"true",
													style:	{ align: "center", px: 5 },
												}),
											],
										}),
										UI_NumberBox({
											position:			"relative",
											x:						10,
											preprocess:		function() {
																			this.display = this.arg.select_edit_unit.udata.capture;
																		},
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											msg:					"Building HP (1-19)",
											min:					1,
											max:					19,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.select_edit_unit.udata.capturenum",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			30,
													height:			20,
													style:	{ align: "right", px: 5 },
												}),
											],
										}),
										// load
										UI_ClickSelector({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].canload ? true : false;
																		},
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.select_edit_unit.udata.load",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"false",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"true",
													style:	{ align: "center", px: 5 },
												}),
											],
										}),
										// stealth
										UI_ClickSelector({
											preprocess:		function() {
																			this.display = Unit[this.arg.select_edit_unit.udata.uname].canstealth ? true : false;
																		},
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.select_edit_unit.udata.stealth",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"false",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"true",
													style:	{ align: "center", px: 5 },
												}),
											],
										}),
										// defence
										UI_ClickSelector({
											position:			"newline",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.select_edit_unit.udata.defence",
											onchange:			function() {
																			this.arg.draw();
																		},
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"false",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"true",
													style:	{ align: "center", px: 5 },
												}),
											],
										}),
									],
			preprocess:	function() {
										this.display = this.arg.select_edit_unit ? true : false;
									},
		});

		this.Container_UEdit = UI_Container({
			value:			"UEdit",
			position:		"absolute",
			lineheight:	30,
			data:				[
										this.Container_UEdit_text,
										this.Container_UEdit_data,
									],
		});

		this.Container_Config = UI_Container({
			value:			"Config",
			position:		"absolute",
			lineheight:	30,
			data:				[
										UI_Button({
											data: 	[
												UI_Drawdata_Text({
													text:				"Animation",
													width:			180,
													height:			20,
												}),
											],
										}),
										UI_ClickSelector({
											position:			"relative",
											x:						0,
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.savedata.config.animation",
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"On",
													style:	{ align: "center", px: 5 },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"Off",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: 	[
												UI_Drawdata_Text({
													text:				"Display Building Number",
													width:			180,
													height:			20,
												}),
											],
										}),
										UI_ClickSelector({
											position:			"relative",
											x:						0,
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.savedata.config.displayterrainnum",
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"On",
													style:	{ align: "center", px: 5 },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"Off",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
											],
										}),
										UI_Button({
											position:	"newline",
											data: 	[
												UI_Drawdata_Text({
													text:				"Display Terrain & Unit Info",
													width:			180,
													height:			20,
												}),
											],
										}),
										UI_ClickSelector({
											position:			"relative",
											x:						0,
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											enablewheel:	"mouseover",
											bindvar:			"this.arg.savedata.config.displayterrainandunitinfo",
											data: 	[
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			true,
													text:				"On",
													style:	{ align: "center", px: 5 },
												}),
												UI_Drawdata_Text({
													width:			50,
													height:			20,
													value:			false,
													text:				"Off",
													style:	{ align: "center", px: 5, fillStyle: "rgb(240, 240, 240)" },
												}),
											],
										}),
									],
		});

		this.Container_Toolmain = UI_Container({
			position:		"newline",
			x: 					0,
			y:					30,
			bindvar:		"this.arg.select_mode",
			style:			this.debug_style,
			data:				[
										this.Container_Terrain,
										this.Container_Unit,
										this.Container_Map,
										this.Container_UEdit,
										this.Container_Config,
									],
		});

		this.animation = function() {
			let time = new Date().getTime();
			if (time - this.prevanimtime > 50) {
				this.prevanimtime = time;
				this.animcounter++;
				this.draw();
			}
			requestAnimationFrame(this.animation);
		}.bind(this);

		this.UI_Base = UI_Base({
			arg: this,
			ctx: this.ctx,
			canvas: this.canvas,
			data: [
				this.Button_new,
				this.Button_open,
				this.Button_save,
				this.Button_sshot,
				this.Selector_Mode,
				this.Container_Toolmain,
			],
		});

		this.init(this.savedata.mapdata.width, this.savedata.mapdata.height, true);

		this.draw();
		this.UI_Base.paint();

		this.prevanimtime = new Date().getTime();
		this.animcounter = 0;
		requestAnimationFrame(this.animation);
	}
	return FWEditor;
}());
